# QuasiMonteCarlo.jl

[![Join the chat at https://julialang.zulipchat.com #sciml-bridged](https://img.shields.io/static/v1?label=Zulip&message=chat&color=9558b2&labelColor=389826)](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged)
[![Global Docs](https://img.shields.io/badge/docs-SciML-blue.svg)](https://docs.sciml.ai/QuasiMonteCarlo/stable/)

[![codecov](https://codecov.io/gh/SciML/QuasiMonteCarlo.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/SciML/QuasiMonteCarlo.jl)
[![Build Status](https://github.com/SciML/QuasiMonteCarlo.jl/workflows/CI/badge.svg)](https://github.com/SciML/QuasiMonteCarlo.jl/actions?query=workflow%3ACI)

[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor%27s%20Guide-blueviolet)](https://github.com/SciML/ColPrac)
[![SciML Code Style](https://img.shields.io/static/v1?label=code%20style&message=SciML&color=9558b2&labelColor=389826)](https://github.com/SciML/SciMLStyle)

This is a lightweight package for generating Quasi-Monte Carlo (QMC) samples
using various different methods.

## Tutorials and Documentation

For information on using the package,
[see the stable documentation](https://docs.sciml.ai/QuasiMonteCarlo/stable/). Use the
[in-development documentation](https://docs.sciml.ai/QuasiMonteCarlo/dev/) for the version of
the documentation, which contains the unreleased features.

## Example

```julia
using QuasiMonteCarlo, Distributions
lb = [0.1, -0.5]
ub = [1.0, 20.0]
n = 5
d = 2

s = QuasiMonteCarlo.sample(n, lb, ub, GridSample())
s = QuasiMonteCarlo.sample(n, lb, ub, Uniform())
s = QuasiMonteCarlo.sample(n, lb, ub, SobolSample())
s = QuasiMonteCarlo.sample(n, lb, ub, LatinHypercubeSample())
s = QuasiMonteCarlo.sample(n, lb, ub, LatticeRuleSample())
s = QuasiMonteCarlo.sample(n, lb, ub, HaltonSample())
```

The output `s` is a matrix, so one can use things like `@uview` from
[UnsafeArrays.jl](https://github.com/oschulz/UnsafeArrays.jl) for a stack-allocated
view of the `i`th point:

```julia
using UnsafeArrays
@uview s[:, i]
```

## API

Everything has the same interface:

```julia
A = QuasiMonteCarlo.sample(n, lb, ub, sample_method, output_type = Float64)
```

or to generate points directly in the unit box $[0,1]^d$

```julia
A = QuasiMonteCarlo.sample(n, d, sample_method, output_type = Float64) # = QuasiMonteCarlo.sample(n,zeros(d),ones(d),sample_method)
```

where:

  - `n` is the number of points to sample.
  - `lb` is the lower bound for each variable. The length determines the dimensionality.
  - `ub` is the upper bound.
  - `d` is the dimension of the unit box.
  - `sample_method` is the quasi-Monte Carlo sampling strategy.
  - `output_type` controls the output type, `Float64`, `Float32`, `Rational` (for exact digital net representation), etc. This feature does not yet work with every QMC sequence.

Additionally, there is a helper function for generating design matrices:

```julia
k = 2
As = QuasiMonteCarlo.generate_design_matrices(n,
    lb,
    ub,
    sample_method,
    k,
    output_type = Float64)
```

which returns `As` which is an array of `k` design matrices `A[i]` that are
all sampled from the same low-discrepancy sequence.

## Available Sampling Methods

Sampling methods `SamplingAlgorithm` are divided into two subtypes

  - `DeterministicSamplingAlgorithm`
    
      + `GridSample` for samples on a regular grid.
      + `SobolSample` for the Sobol sequence.
      + `FaureSample` for the Faure sequence.
      + `LatticeRuleSample` for a randomly-shifted rank-1 lattice rule.
      + `HaltonSample` for the Halton sequence.
      + `GoldenSample` for a Golden Ratio sequence.
      + `KroneckerSample(alpha, s0)` for a Kronecker sequence, where alpha is a length-`d` vector of irrational numbers (often `sqrt(d)`) and `s0` is a length-`d` seed vector (often `0`).

  - `RandomSamplingAlgorithm`
    
      + `UniformSample` for uniformly distributed random numbers.
      + `LatinHypercubeSample` for a Latin Hypercube.
      + Additionally, any `Distribution` can be used, and it will be sampled from.
    
    <!-- - `SectionSample(x0, sampler)` where `sampler` is any sampler above and `x0` is a vector of either `NaN` for a free dimension or some scalar for a constrained dimension. Not currently supported. -->

## Adding a new sampling method

Adding a new sampling method is a two-step process:

 1. Add a new SamplingAlgorithm type.
 2. Overload the sample function with the new type.

All sampling methods are expected to return a matrix with dimension `d` by `n`, where `d` is the dimension of the sample space and `n` is the number of samples.

**Example**

```julia
struct NewAmazingSamplingAlgorithm{OPTIONAL} <: SamplingAlgorithm end

function sample(n, lb, ub, ::NewAmazingSamplingAlgorithm)
    if lb isa Number
        ...
        return x
    else
        ...
        return reduce(hcat, x)
    end
end
```

## Randomization of QMC sequences

Most of the previous methods are deterministic, i.e. `sample(n, d, Sampler()::DeterministicSamplingAlgorithm)` always produces the same sequence $X = (X_1, \dots, X_n)$.
There are two ways to obtain a randomized sequence:

  - Either directly use `QuasiMonteCarlo.sample(n, d, DeterministicSamplingAlgorithm(R = RandomizationMethod()))` or `sample(n, lb, up, DeterministicSamplingAlgorithm(R = RandomizationMethod()))`.
  - Or, given $n$ points $d$-dimensional points, all in $[0,1]^d$ one can do `randomize(X, ::RandomizationMethod())` where $X$ is a $d\times n$-matrix.

The currently available randomization methods are:

  - Scrambling methods `ScramblingMethods(b, pad, rng)` where `b` is the base used to scramble and `pad` the number of bits in `b`-ary decomposition.
    `pad` is generally chosen as $\gtrsim \log_b(n)$.
    The implemented `ScramblingMethods` are
    
      + `DigitalShift`
      + `MatousekScramble` a.k.a. Linear Matrix Scramble.
      + `OwenScramble` a.k.a. Nested Uniform Scramble is the most understood theoretically, but is more costly to operate.

  - `Shift(rng)` a.k.a. Cranley Patterson Rotation.

For numerous independent randomization, use `generate_design_matrices(n, d, ::DeterministicSamplingAlgorithm), ::RandomizationMethod, num_mats)` where `num_mats` is the number of independent `X` generated.

### Randomization Example

Randomization of a Faure sequence with various methods.

```julia
using QuasiMonteCarlo
m = 4
d = 3
b = QuasiMonteCarlo.nextprime(d)
N = b^m # Number of points
pad = m # Length of the b-ary decomposition number = sum(y[k]/b^k for k in 1:pad)

# Unrandomized (deterministic) low discrepancy sequence
x_faure = QuasiMonteCarlo.sample(N, d, FaureSample())

# Randomized version
x_nus = randomize(x_faure, OwenScramble(base = b, pad = pad)) # equivalent to sample(N, d, FaureSample(R = OwenScramble(base = b, pad = pad)))
x_lms = randomize(x_faure, MatousekScramble(base = b, pad = pad))
x_digital_shift = randomize(x_faure, DigitalShift(base = b, pad = pad))
x_shift = randomize(x_faure, Shift())
x_uniform = rand(d, N) # plain i.i.d. uniform
```

```julia
using Plots
# Setting I like for plotting
default(fontfamily = "Computer Modern",
    linewidth = 1,
    label = nothing,
    grid = true,
    framestyle = :default)
```

Plot the resulting sequences along dimensions `1` and `3`.

```julia
d1 = 1
d2 = 3 # you can try every combination of dimensions (d1, d2)
sequences = [x_uniform, x_faure, x_shift, x_digital_shift, x_lms, x_nus]
names = [
    "Uniform",
    "Faure (deterministic)",
    "Shift",
    "Digital Shift",
    "Matousek Scramble",
    "Owen Scramble"
]
p = [plot(thickness_scaling = 1.5, aspect_ratio = :equal) for i in sequences]
for (i, x) in enumerate(sequences)
    scatter!(p[i], x[d1, :], x[d2, :], ms = 0.9, c = 1, grid = false)
    title!(names[i])
    xlims!(p[i], (0, 1))
    ylims!(p[i], (0, 1))
    yticks!(p[i], [0, 1])
    xticks!(p[i], [0, 1])
    hline!(p[i], range(0, 1, step = 1 / 4), c = :gray, alpha = 0.2)
    vline!(p[i], range(0, 1, step = 1 / 4), c = :gray, alpha = 0.2)
    hline!(p[i], range(0, 1, step = 1 / 2), c = :gray, alpha = 0.8)
    vline!(p[i], range(0, 1, step = 1 / 2), c = :gray, alpha = 0.8)
end
plot(p..., size = (1500, 900))
```

![Different randomization methods of the same initial set of points](img/various_randomization.svg)

"""
    GridSample(R::RandomizationMethod = NoRand()) <: DeterministicSamplingAlgorithm

A simple rectangular grid lattice. Samples `n` random samples from a grid with `dx = (ub -lb)/n``

In more than 2 dimensions, grids have worse discrepancy than simple Monte Carlo. As a
result, they should almost never be used for multivariate integration; their use is as
a starting point for other algorithms.
"""
Base.@kwdef @concrete struct GridSample <: DeterministicSamplingAlgorithm
    R::RandomizationMethod = NoRand()
end

function sample(n::Integer, d::Integer, S::GridSample, T = Float64)
    samples = rand.(range.(zeros(T, d), ones(T, d); length = n + 1), Ref(n))
    return randomize(mapreduce(permutedims, vcat, samples), S.R)
end

"""
    LatticeRuleSample() <: DeterministicSamplingAlgorithm

Generate a point set using a lattice rule.
"""
Base.@kwdef @concrete struct LatticeRuleSample <: DeterministicSamplingAlgorithm
    R::RandomizationMethod = NoRand()
end

function sample(n::Integer, d::Integer, S::LatticeRuleSample, T = Float64)
    lat = LatticeRules.LatticeRule(d)
    result = reduce(hcat, lat[0:(n - 1)])
    return randomize(T == Float64 ? result : T.(result), S.R)
end

"""
    unif2bits(x<:AbstractArray, b::Integer; pad=32)

Return the b-ary decomposition of all element y of an array y = ∑ₖ yₖ/bᵏ a number yₖ∈[0,1[ -> [y₁, ⋯, yₘ]
"""
function unif2bits(x::AbstractArray, b::I; pad = 32) where {I <: Integer}
    bits = zeros(I, pad, size(x)...)
    unif2bits!(bits, x, b)
    return bits
end

function unif2bits!(bits::AbstractArray, x::AbstractArray, b::Integer)
    @assert all([size(bits, d + 1) == size(x, d) for d in ndims(x)]) "Bit array of size $(size(bits)) instead of (pad, $(size(x)))"
    for i in CartesianIndices(x)
        unif2bits!(@view(bits[:, i]), x[i], b)
    end
    return
end

"""
    unif2bits(y<:Real, b::Integer; pad=32)

Return the b-ary decomposition y = ∑ₖ yₖ/bᵏ a number y∈[0,1[ -> [y₁, ⋯, yₘ]
"""
function unif2bits(y::Real, b::I; pad = 32) where {I <: Integer}
    bits = zeros(I, pad)
    unif2bits!(bits, y, b)
    return bits
end

# Inspired by digits!(a::AbstractVector{T}, n::Integer; base) where T<:Integer in Base at intfuncs.jl:926
function unif2bits!(bits::AbstractVector{<:Integer}, y::Real, b::Integer; kwargs...)
    invbase = inv(b)
    for i in eachindex(bits)
        r, y = divrem(y, invbase^i)
        bits[i] = r
    end
    return
end

#? Apparently this is not ideal to explicitly state the Type.
#? See https://github.com/SciML/QuasiMonteCarlo.jl/issues/44#issuecomment-1328156825
#? Not sure how to do otherwise in this case though.
"""
    bits2unif(::Type{T}, bits::AbstractVector{<:Integer},
                   b::Integer)

Convert a vector of pad "bits" in base b into a number y∈[0,1[.
"""
function bits2unif(
        ::Type{T}, bits::AbstractVector{<:Integer},
        b::Integer
    ) where {T <: Rational}
    # Turn sequence of bits into a point in [0,1)
    # First bits are highest order
    y = zero(T)
    for j in lastindex(bits):-1:1
        y = (y + bits[j]) // b
    end
    return y
end

function bits2unif(
        ::Type{T}, bits::AbstractVector{<:Integer},
        b::Integer
    ) where {T <: AbstractFloat}
    # Turn sequence of bits into a point in [0,1)
    # First bits are highest order
    y = zero(T)
    for j in lastindex(bits):-1:1
        y = (y + bits[j]) / b
    end
    return y
end

function bits2unif(bits::AbstractVector{<:Integer}, b::Integer)
    return bits2unif(Float64, bits::AbstractVector{<:Integer}, b::Integer)
end

#? This seems faster than @evalpoly(b, $bit...)
#?  bi = rand(0:2,32);
#? @btime @evalpoly(3, $bi...)
#?   500.515 ns (1 allocation: 272 bytes)
#? @btime QuasiMonteCarlo.bits2int($bi, 3)
#?   13.113 ns (0 allocations: 0 bytes)
"""
    bits2int(bit::AbstractMatrix{<:Integer}, b::Integer)

Convert a vector of pad "bits" in base b into an integer.
"""
function bits2int(bit::AbstractVector, b::I) where {I <: Integer}
    m = length(bit)
    y = zero(I)
    for k in m:-1:1
        y = y * b + bit[k]
    end
    return y
end

"""
    VanDerCorputSample(base::Integer, R::RandomizationMethod = NoRand()) <: DeterministicSamplingAlgorithm

The van der Corput sequence, also called the radical inverse sequence, is a one-dimensional
low-discrepancy sequence that recursively splits the unit interval into equally-sized
pieces before inserting one sample in each interval.

For example, in base 2, the sequence starts by inserting one point in each half of the unit
interval in the first pass (the first 2 samples); then one sample in each quarter, then each
eighth, and so on. This creates a well-stratified sample, so long as the number of samples
is a multiple of a power of the base.
"""
Base.@kwdef @concrete struct VanDerCorputSample{I <: Integer} <:
    DeterministicSamplingAlgorithm
    base::I
    R::RandomizationMethod = NoRand()
end

function sample(n::Integer, d::Integer, S::VanDerCorputSample, T::Type = Float64)
    @assert d == 1 "Van der Corput sequence only supports 1D sampling"
    @assert n > 0 ZERO_SAMPLES_MESSAGE
    base = S.base
    log_n = log(base, n)
    t = floor(Int, log_n)
    n_digits = ceil(Int, log_n)
    λ = n ÷ (base^t)
    return randomize(_vdc(promote(λ, n_digits, base)..., T; n), S.R)
end

"""
    _vdc(λ::Integer, n_digits::Integer, base::Integer, F=Float64)
    _vdc(n::Integer, base::Integer, F=Float64)

Generate a Van der Corput sequence of length `n=λ*base^n_digits` in the given base, where
`λ` is the number of samples per subinterval, and `base^n_digits` is the number of subintervals.

Note that `λ` must be smaller than `base` for the sequence to be well-stratified.
"""
function _vdc(n::I, base::I, F = Float64) where {I <: Integer}
    return _vdc(one(n), I(log(base, n)), base, F; n)
end
@fastmath @views function _vdc(
        λ::I, n_digits::I, base::I, F = Float64;
        n = λ * base^n_digits
    ) where {I <: Integer}
    sequence = zeros(F, n)
    inv_base = convert(F, inv(base))
    dgs = fill(base - 1, n_digits)
    # offset required to place samples in center of interval
    offset = convert(F, inv(2n))
    for sample_idx in eachindex(sequence)
        # increment digit counter by 1
        _base_sum!(dgs, base)
        sequence[sample_idx] = evalpoly(inv_base, dgs) * inv_base + offset
    end
    return sequence
end

@fastmath @views function _base_sum!(dgs::AbstractVector, base::Integer)
    @label start # for recursion
    dgs[1] = one(eltype(dgs)) + dgs[1]
    if dgs[1] == base
        dgs[1] = zero(eltype(dgs))
        if length(dgs) ≠ 1  # ignore overflows
            dgs = dgs[2:end]
            @goto start  # recursive call
        end
    end
    return parent(dgs)
end

using QuasiMonteCarlo
using Test

using Statistics, LinearAlgebra, StatsBase, Random
using Primes, Combinatorics, Distributions, IntervalArithmetic
using HypothesisTests

# struct InertSampler <: Random.AbstractRNG end
# InertSampler(args...; kwargs...) = InertSampler()
# Random.rand(::InertSampler, ::Type{T}) where {T} = zero(T)
# Random.rand(::InertSampler) = 0
# Random.shuffle!(::InertSampler, arg::AbstractArray) = arg

@views function embiggen!(a::Vector{T}, new_len::Integer, pad::T) where {T}
    old_len = length(a)
    @assert new_len ≥ old_len "Can't embiggen something smaller"
    if new_len == old_len
        return a
    elseif new_len == old_len + 1
        push!(a, pad)
        return a
    else
        append!(a, fill(pad, new_len - old_len))
        return a
    end
end

####################
### T, pad, S NETS ###
####################

"""
    istmsnet(net::AbstractMatrix{T}; λ::I, t::I, m::I, d::I, base::I) where {I <: Integer, T <: Real}

Test if a point set `net` (`dim×n`) is a `(λ,t,m,s)`-net in base `b`.

`(λ,t,m,s)`-nets have strict equidistribution properties making them good QMC sequences.
Their definition and properties can be found in the book [Monte Carlo theory, methods, and examples](https://artowen.su.domains/mc/qmcstuff.pdf) by Art B. Owen.
See Definition 15.7 and for properties see Chapter 15 to 17.

The test is exact if the element of `net` are of type `Rational`. Indeed, in that case, one can exactly deal with points at the edge of intervals of the form [a,b)ᵈ.
The conversion `Float` to `Rational` is usually possible with usual nets, e.g., Sobol, Faure (may require `Rational{BigInt}.(net)`).
"""
function istmsnet(
        net::AbstractMatrix{T}; λ::I, t::I, m::I, s::I,
        base::I
    ) where {I <: Integer, T <: Real}
    pass = true

    @assert size(net, 2) == λ * (base^m) "Number of points must be as size(net, 2) = $(size(net, 2)) == λ * (base^m) = $(λ * (base^m))"
    @assert size(net, 1) == s "Dimension must be as size(net, 2) = $(size(net, 2)) == s = $s"
    @assert all(0 .≤ net .< 1) "All points must be in [0,1)"

    perms = multiexponents(s, m - t)
    for stepsize in perms
        intervals = mince(
            IntervalBox([interval(zero(T), one(T)) for i in 1:s]),
            NTuple{s, Int}(base .^ stepsize)
        )
        pass &= all(intervals) do intvl
            λ * base^t == count(point -> inCloseOpen(point, intvl), collect(eachcol((net))))
        end
        if !pass
            println("Errors in direction k = $stepsize")
            return pass
        end
    end
    return pass
end

"""
    in_halfopen(x, a)

Checks if the number `x` is a member of the interval `a` (close on the left and open on the right), treated as a set.
"""
function inCloseOpen(x::T, a::Interval) where {T <: Real}
    isinf(x) && return false
    return a.lo <= x < a.hi
end
inCloseOpen(X::AbstractVector, Y::IntervalBox{N, T}) where {N, T} = all(inCloseOpen.(X, Y))

rng = MersenneTwister(1776)

#1D
lb = 0.0
ub = 1.0
n = 8
d = 1

for point_constructor in [
        FaureSample(),
        GridSample(),
        HaltonSample(),
        KroneckerSample(),
        LatinHypercubeSample(),
        LatticeRuleSample(),
        RandomSample(),
        SobolSample(),
    ]
    @show point_constructor
    s = QuasiMonteCarlo.sample(n, lb, ub, point_constructor)
    @test all(all(x .<= ub) for x in eachcol(s))
    @test all(all(x .>= lb) for x in eachcol(s))
    @test isa(s, Matrix) == true
    @test size(s) == (d, n)
end

for (sampler, d) in Iterators.product([Cauchy(), Normal(0, 4)], 1:3)
    @show sampler
    s = QuasiMonteCarlo.sample(n, d, sampler)
    @test s isa Matrix
    @test size(s) == (d, n)
end

@testset "1D" begin
    # @testset "SectionSample" begin
    #     constrained_val = 1.0
    #     point_constructor = SectionSample([NaN64], RandomSample())
    #     s = QuasiMonteCarlo.sample(n, lb, ub, point_constructor)
    #     @test s isa Vector{Float64}
    #     @test length(s) == n
    #     @test all(x -> lb ≤ x ≤ ub, s)
    #     @test !all(==(constrained_val), s)
    #     @test QuasiMonteCarlo.free_dimensions(point_constructor) == [1]
    #     @test QuasiMonteCarlo.fixed_dimensions(point_constructor) == Int[]

    #     point_constructor = SectionSample([constrained_val], RandomSample())
    #     s = QuasiMonteCarlo.sample(n, lb, ub, point_constructor)
    #     @test s isa Vector{Float64} && length(s) == n && all(x -> lb ≤ x ≤ ub, s)
    #     @test all(==(constrained_val), s)
    #     @test QuasiMonteCarlo.free_dimensions(point_constructor) == Int[]
    #     @test QuasiMonteCarlo.fixed_dimensions(point_constructor) == [1]

    #     #n = 0
    #     @test_throws QuasiMonteCarlo.ZeroSamplesError QuasiMonteCarlo.sample(0, lb, ub,
    #                                                                          point_constructor)
    # end
end

#ND
@testset "GridSample" begin
    lb = [0.0, 0.0]
    ub = [1.0, 1.0]
    n = 64
    d = 4

    Random.seed!(1776)
    s = QuasiMonteCarlo.sample(n, lb, ub, GridSample())
    s = sortslices(s; dims = 2)
    differences = diff(s; dims = 2)
    # test for grid
    @test all(x -> all(y -> y in 0.0:(1 / n):1.0, x), eachrow(s))
    μ = mean(s; dims = 2)
    variance = var(s; corrected = false, dims = 2)
    for i in eachindex(μ)
        @test μ[i] ≈ 0.5 atol = 2 / sqrt(n)
        @test variance[i] ≈ 1 / 12 rtol = 2 / sqrt(n)
    end
end

@testset "RandomSample" begin
    lb = [0.0, 0.0]
    ub = [1.0, 1.0]
    n = 20_000
    d = length(lb)

    s = QuasiMonteCarlo.sample(n, lb, ub, RandomSample(rng))
    @test size(s) == (d, n)

    μ = mean(s; dims = 2)
    variance = var(s; dims = 2)
    for i in eachindex(μ)
        @test μ[i] ≈ 0.5 atol = 2 / sqrt(n)
        @test variance[i] ≈ 1 / 12 rtol = 2 / sqrt(n)
    end
    @test pvalue(SignedRankTest(eachrow(s)...)) > 0.0001
end

@testset "LHS" begin
    lb = [0.0, 0.0]
    ub = [1.0, 1.0]
    d = length(lb)
    n = 20_000

    s = QuasiMonteCarlo.sample(n, lb, ub, LatinHypercubeSample(rng))
    @test size(s) == (d, n)

    μ = mean(s; dims = 2)
    variance = var(s; dims = 2)
    for i in eachindex(μ)
        @test μ[i] ≈ 0.5 atol = 2 / sqrt(n)
        @test variance[i] ≈ 1 / 12 rtol = 2 / sqrt(n)
    end
    @test pvalue(SignedRankTest(eachrow(s)...)) > 0.0001

    # A LHS is a scrambled `(λ=1, t=0, m=1, s=d)`-net in base `n`
    # See Cororollary 17.1 of [Monte Carlo theory, methods, and examples](https://artowen.su.domains/mc/qmcstuff.pdf).
    @test istmsnet(s, λ = 1, t = 0, m = 1, s = d, base = n)
end

@testset "Van der Corput Sequence" begin
    lb = 0
    ub = 1
    for base in [2, 3, 4]
        n = base^4
        s = QuasiMonteCarlo.sample(n, lb, ub, VanDerCorputSample(base, NoRand()))
        @test all(diff(sort(s)) .≈ 1 / n)
        @test all(s .≥ lb)
        @test all(s .≤ ub)
        @test 1 - maximum(s) ≈ minimum(s)
        @test minimum(s) ≈ inv(2n)
        @test mean(s) ≈ 0.5
        @test var(s; corrected = false) ≈ 1 / 12 rtol = 2 / sqrt(n)
    end
end

@testset "SobolSample" begin
    lb = [0.0, 0.0, 0.0]
    ub = [1.0, 1.0, 1.0]
    d = length(lb)
    power = 6
    base = 2
    n = base^power

    s = QuasiMonteCarlo.sample(n, lb, ub, SobolSample())
    @test s isa Matrix
    @test size(s) == (d, n)
    vdc = QuasiMonteCarlo.sample(n, 1, VanDerCorputSample(base, NoRand()))
    sort!(vdc)
    for (i, j) in combinations(1:d, 2)
        @test pvalue(SignedRankTest(s[i, :], s[j, :])) > 0.0001
    end
    @test istmsnet(s; λ = 1, t = power - d, m = power, s = d, base)
    for dim in sort.(eachrow(s))
        # all dimensions should be base-2 van der Corput
        @test dim ≈ vdc
    end
    μ = mean(s; dims = 2)
    variance = var(s; dims = 2)
    for i in eachindex(μ)
        @test μ[i] ≈ 0.5 atol = 2 / n
        @test variance[i] ≈ 1 / 12 rtol = 2 / n
    end
end

@testset "Faure Sample" begin
    #FaureSample()
    d = 17
    base = nextprime(d)
    power = 2
    n = 17^2
    sampler = FaureSample()
    @test_throws ArgumentError QuasiMonteCarlo.sample(d + 1, d, sampler)
    @test_throws ArgumentError QuasiMonteCarlo.sample(d^2 + 1, d, sampler)
    s = sortslices(QuasiMonteCarlo.sample(n, d, sampler); dims = 2)
    # FaureSample() generates centered boxes, unlike DiceDesign
    r = sortslices(include("shared/rfaure.jl")'; dims = 2) .+ inv(2base^(power + 1))

    @test s isa Matrix
    @test size(s) == (d, n)
    @test mean(abs, s - r) ≤ 2 / n
    @test s ≈ r

    μ = mean(s; dims = 2)
    variance = var(s; dims = 2)
    for i in eachindex(μ)
        @test μ[i] ≈ 0.5 atol = 2 / n
        @test variance[i] ≈ 1 / 12 rtol = 2 / n
    end
    for (i, j) in combinations(1:d, 2)
        @test pvalue(SignedRankTest(s[i, :], s[j, :])) > 0.0001
    end
    # test 5d stratification of first 3 primes
    power = 5
    for d in (2, 3, 5)
        base = nextprime(d)
        n = base^power
        s = QuasiMonteCarlo.sample(n, d, sampler)
        @test istmsnet(s; λ = 1, t = 0, m = power, s = d, base)
    end
    # test 2d stratification of next 3 primes
    power = 2
    for d in (7, 11, 13)
        base = nextprime(d)
        λ = 2
        n = λ * base^power
        s = QuasiMonteCarlo.sample(n, d, sampler)
        @test istmsnet(s; λ, t = 0, m = power, s = d, base)  # test 3d stratification of next 3 primes
    end
end

@testset "(Randomized) Halton Sequence" begin
    d = 4
    lb = zeros(d)
    ub = ones(d)
    bases = nextprimes(1, d)
    n = prod(bases)^2
    for sample_type in [HaltonSample(), RandomizedHaltonSample()]
        s = QuasiMonteCarlo.sample(n, lb, ub, sample_type)
        @test isa(s, Matrix)
        @test size(s) == (d, n)
        sorted = reduce(vcat, sort.(eachslice(s; dims = 1))')
        each_dim = eachrow(sorted)

        # each 1d sequence should have base b stratification property
        # (property inherited from van der Corput)
        @test all(zip(each_dim, bases)) do (seq, base)
            theoretical_count = n ÷ base
            part = Iterators.partition(seq, theoretical_count)
            all(enumerate(part)) do (i, subseq)
                all(subseq) do x
                    i - 1 ≤ base * x ≤ i
                end
            end
        end
        μ = mean(s; dims = 2)
        variance = var(s; dims = 2)
        for i in eachindex(μ)
            @test μ[i] ≈ 0.5 atol = 1 / sqrt(n)
            @test variance[i] ≈ 1 / 12 rtol = 1 / sqrt(n)
        end
        for (i, j) in combinations(1:d, 2)
            @test pvalue(SignedRankTest(s[i, :], s[j, :])) > 0.0001
        end
    end
end

@testset "LatticeRuleSample" begin
    #LatticeRuleSample()
    s = QuasiMonteCarlo.sample(n, lb, ub, LatticeRuleSample())
    @test isa(s, Matrix)
    @test size(s) == (d, n)
    μ = mean(s; dims = 2)
    variance = var(s; dims = 2)
    for i in eachindex(μ)
        @test μ[i] ≈ 0.5 atol = 3 / n
        @test variance[i] ≈ 1 / 12 rtol = 3 / n
    end
end

@testset "Kronecker" begin
    d = 2
    n = 100
    ρ = 0.7548776662466927
    s = QuasiMonteCarlo.sample(n, d, KroneckerSample([ρ, ρ^2], NoRand()))
    t = QuasiMonteCarlo.sample(n, d, GoldenSample())
    @test isa(s, Matrix{Float64})
    @test size(s) == (d, n)
    @test s ≈ t
    differences = eachcol(mod.(diff(s; dims = 2), 1))
    @test all(x -> x ≈ first(differences), differences)
end

# @testset "Section Sample" begin
#     lb = [0.0, 0.0]
#     ub = [1.0, 1.0]
#     n = 5
#     d = 2
#     constrained_val = 1.0
#     point_constructor = SectionSample([NaN64, constrained_val], RandomSample())
#     s = QuasiMonteCarlo.sample(n, lb, ub, point_constructor)
#     @test all(s[2, :] .== constrained_val)
#     @test isa(s, Matrix{Float64})
#     @test size(s) == (d, n)
#     @test all(lb[1] .≤ s[1, :] .≤ ub[1])
#     @test QuasiMonteCarlo.fixed_dimensions(point_constructor) == [2]
#     @test QuasiMonteCarlo.free_dimensions(point_constructor) == [1]

#     constrained_val = 2.0
#     d = 3
#     point_constructor = SectionSample([NaN64, constrained_val, NaN64], SobolSample())
#     @test QuasiMonteCarlo.free_dimensions(point_constructor) == [1, 3]
#     @test QuasiMonteCarlo.fixed_dimensions(point_constructor) == [2]
#     lb = [-1.0, constrained_val, -1.0]
#     ub = [6.0, constrained_val, 6.0]
#     s = QuasiMonteCarlo.sample(n, lb, ub, point_constructor)

#     @test all(lb[1] .≤ s[1, :] .≤ ub[1])
#     @test all(lb[3] .≤ s[3, :] .≤ ub[3])
#     @test all(s[2, :] .== constrained_val)
#     @test isa(s, Matrix{Float64})
#     @test size(s) == (d, n)

#     #n = 0
#     @test_throws QuasiMonteCarlo.ZeroSamplesError QuasiMonteCarlo.sample(0, lb, ub,
#                                                                          SectionSample([
#                                                                                            NaN64,
#                                                                                            constrained_val,
#                                                                                        ],
#                                                                                        RandomSample()))
# end

@testset "generate_design_matrices" begin
    d = 4
    m = 8
    lb = zeros(d)
    ub = ones(d)
    num_mat = 3
    n = 2^m
    algorithms = [
        RandomSample(),
        LatinHypercubeSample(),
        SobolSample(R = OwenScramble(base = 2, pad = m)),
        SobolSample(),
        LatticeRuleSample(R = Shift()),
        SobolSample(R = MatousekScramble(base = 2, pad = m)),
    ]
    for algorithm in algorithms
        Ms = QuasiMonteCarlo.generate_design_matrices(n, lb, ub, algorithm, num_mat)
        @test length(Ms) == num_mat
        A = Ms[1]
        B = Ms[2]
        @test isa(A, Matrix{typeof(A[1][1])}) == true
        @test size(A) == (d, n)
        @test isa(B, Matrix{typeof(B[1][1])}) == true
        @test size(B) == (d, n)
    end
end

@testset "iterators" begin
    d = 4
    m = 14
    n = 2^m
    num_mat = 4

    f(x) = prod(x) * 2^length(x) # test function ∫f(x)dᵈx = 1

    algorithms = [
        RandomSample(),
        Beta(0.2, 0.8),
        # LatticeRuleSample(R = Shift()), # TODO add support for LatticeRule
        SobolSample(R = OwenScramble(base = 2, pad = m)),
        SobolSample(R = MatousekScramble(base = 2, pad = m)),
        SobolSample(R = DigitalShift(base = 2, pad = m)),
    ]
    for algorithm in algorithms
        @show algorithm
        iterator = DesignMatrix(n, d, algorithm, num_mat)
        X = QuasiMonteCarlo.next!(iterator)
        @test isa(X, Matrix{eltype(X)}) == true
        μ = [mean(f(c) for c in eachcol(X)) for X in iterator] # Check that iterator do work!
        if !isa(algorithm, Beta) # The Beta distribution is not Uniform hence we do not expect the μ to be close to 1. We could compute the expected results but it would involve a β function dependency.
            @test μ ≈ ones(num_mat) atol = 5.0e-2 # the results for different randomization should all be close to 1. Arbitrarily we allow 5% error.
        end
    end
end

@testset "Types of output and intermediate arrays" begin
    # Scrambling methods use intermediate array for the bits scrambling. It is in general unnecessary to have this large array stored as Int64.
    #TODO test other randomization methods (here just scrambling) and QMC sequence (here just Sobol)
    #TODO here we test output and constructions of intermediate array, we could test that all operation are type stables
    d = 4
    m = 12
    n = 2^m

    for type in [Float32, Float64]
        for Int_type in [Int32, Int64]
            b, pad = Int_type(2), Int_type(32)
            scramblings = [
                OwenScramble(base = b, pad = pad)
                MatousekScramble(base = b, pad = pad)
                DigitalShift(base = b, pad = pad)
            ]
            for scrambling in scramblings
                output,
                    other_arrays... = QuasiMonteCarlo.initialize(
                    n,
                    d,
                    SobolSample(),
                    scrambling,
                    type
                )
                @test output isa Matrix{type}
                @test all(
                    [
                        other_array isa Array{Int_type, 3}
                            for other_array in other_arrays
                    ]
                )

                iterator = DesignMatrix(n, d, SobolSample(), scrambling, 1, type)
                scrambled_output = QuasiMonteCarlo.next!(iterator)
                @test scrambled_output isa Matrix{type}
            end
        end
    end
end

@testset "Randomized Quasi Monte Carlo: conversion functions" begin
    b = 2
    x = (0 // 16):(1 // 16):(15 // 16)
    bits = QuasiMonteCarlo.unif2bits(x, b)
    y = [QuasiMonteCarlo.bits2unif(s, b) for s in eachcol(bits)]
    @test x == y

    b = 3
    x = (0 // 27):(1 // 27):(26 // 27)
    bits = QuasiMonteCarlo.unif2bits(x, b, pad = 8)
    y = [QuasiMonteCarlo.bits2unif(Rational, s, b) for s in eachcol(bits)]
    @test x == y
end

@testset "Randomized Quasi Monte Carlo" begin
    m = 6
    d = 5
    b = QuasiMonteCarlo.nextprime(d)
    N = b^m # Number of points
    pad = 2m

    # Unrandomized low discrepancy sequence
    u_faure = QuasiMonteCarlo.sample(N, d, FaureSample())

    # Randomized version
    @test u_faure == randomize(u_faure, NoRand())
    u_nus = randomize(u_faure, OwenScramble(base = b, pad = pad))
    u_lms = randomize(u_faure, MatousekScramble(base = b, pad = pad))
    u_digital_shift = randomize(u_faure, DigitalShift(base = b, pad = pad))
    u_shift = randomize(u_faure, Shift())

    u_nus = QuasiMonteCarlo.sample(N, d, FaureSample(OwenScramble(base = b, pad = pad)))
end

@testset "Randomized Quasi Monte Carlo Rational Scrambling" begin
    m = 5
    d = 2
    b = QuasiMonteCarlo.nextprime(d)
    N = b^m # Number of points
    pad = m

    # Unrandomized low discrepancy sequence
    u_sobol = Rational.(QuasiMonteCarlo.sample(N, d, SobolSample()))
    # Randomized version
    u_nus = randomize(u_sobol, OwenScramble(base = b, pad = pad))
    u_lms = randomize(u_sobol, MatousekScramble(base = b, pad = pad))
    u_digital_shift = randomize(u_sobol, DigitalShift(base = b, pad = pad))
    @test eltype(u_nus) <: Rational
    @test eltype(u_lms) <: Rational
    @test eltype(u_digital_shift) <: Rational
end

@testset "Sobol' sequence are (tₛ,m,s)-net in base 2 even after scrambling" begin
    #! Note that this is the first 2ᵐ elements of the sequence which are tested
    #! Note that the Sobol' sequence from Sobol.jl is the "controversed" version where the first element have be removed

    # Table of qualitity parameter t with respect to dimension s for Sobol' sequence.
    # See "The algebraic-geometry approach to low-discrepancy sequences" H Niederreiter, C Xing - Monte Carlo and Quasi-Monte Carlo Methods 1996, 1998
    t_sobol = [0, 0, 1, 3, 5, 8, 11, 15, 19, 23, 27, 31, 35, 40, 45, 50, 55, 60, 65, 71]

    m = 12
    base = 2
    n = base^m
    λ = 1
    v = [
        NoRand(),
        OwenScramble(base = base, pad = m),
        MatousekScramble(base = base, pad = m),
        DigitalShift(base = base, pad = m),
    ]
    pass = Array{Bool}(undef, length(v), m)
    for (s, t) in enumerate(t_sobol[1:m])
        net = Rational.(QuasiMonteCarlo.sample(n, s, SobolSample()))
        for j in eachindex(v)
            pass[j, s] = istmsnet(
                randomize(net, v[j]); λ, t, m, s,
                base = base
            )
        end
    end
    @test all(pass)
end

@testset "Faure sequence are (0,m,s)-net even after scrambling" begin
    # Faure sequence are exactly (t=0, s)-sequence in base b=nextprime(s)
    m = 4
    pad = m
    λ = 1
    t = 0

    pass = Array{Bool}(undef, 4, m)
    for s in 1:m
        net = Rational{BigInt}.(QuasiMonteCarlo.sample(nextprime(s)^m, s, FaureSample())) # Convert the sequence in Rational{BigInt} (needed to scramble)
        pass[1, s] = istmsnet(
            randomize(net, NoRand()); λ, t, m, s,
            base = nextprime(s)
        )
        pass[2, s] = istmsnet(
            randomize(net, OwenScramble(base = nextprime(s), pad = m));
            λ, t, m, s, base = nextprime(s)
        )
        pass[3, s] = istmsnet(
            randomize(
                net,
                MatousekScramble(base = nextprime(s), pad = m)
            );
            λ, t, m, s, base = nextprime(s)
        )
        pass[4, s] = istmsnet(
            randomize(net, DigitalShift(base = nextprime(s), pad = m));
            λ, t, m, s, base = nextprime(s)
        )
    end
    @test all(pass)
end

"""
    LatinHypercubeSample(rng::AbstractRNG = Random.TaskLocalRNG()) <: RandomSamplingAlgorithm

A Latin Hypercube is a point set with the property that every one-dimensional interval `(i/n, i+1/n)` contains exactly one point. This is a good way to sample a high-dimensional space, as it is more uniform than a random sample but does not require as many points as a full net.
"""
Base.@kwdef @concrete struct LatinHypercubeSample <: RandomSamplingAlgorithm
    rng::AbstractRNG = Random.TaskLocalRNG()
end

function sample(n::Integer, d::Integer, S::LatinHypercubeSample, T = Float64)
    _check_sequence(n)
    rng = S.rng
    seq = ((1:n) .- convert(T, 0.5)) / n
    # TODO: Probably a more efficient way to do this
    return reduce(vcat, [shuffle(rng, seq)' for _ in 1:d])
end

using QuasiMonteCarlo
using Test

struct ConstantSampler <: SamplingAlgorithm end

hasdoc(mod::Module, name::Symbol) = haskey(Base.Docs.meta(mod), Base.Docs.Binding(mod, name))

function QuasiMonteCarlo.sample(
        n::Integer, d::Integer, ::ConstantSampler, T = Float64
    )
    n > 0 || throw(ArgumentError("n must be positive"))
    d > 0 || throw(ArgumentError("d must be positive"))
    return fill(convert(T, 0.5), d, n)
end

@testset "Public sampling APIs" begin
    @test isdefined(QuasiMonteCarlo, :sample)
    @static if VERSION >= v"1.11"
        @test Base.ispublic(QuasiMonteCarlo, :sample)
    else
        @test Base.isexported(QuasiMonteCarlo, :sample)
    end
    @test hasdoc(QuasiMonteCarlo, :sample)

    @test isdefined(QuasiMonteCarlo, :generate_design_matrices)
    @test Base.isexported(QuasiMonteCarlo, :generate_design_matrices)
    @test hasdoc(QuasiMonteCarlo, :generate_design_matrices)

    unit_points = sample(3, 2, ConstantSampler(), Float32)
    @test size(unit_points) == (2, 3)
    @test eltype(unit_points) == Float32
    @test all(0 .<= unit_points .<= 1)

    bounded_points = sample(3, [-2.0, 4.0], [2.0, 6.0], ConstantSampler())
    @test bounded_points == [-0.0 -0.0 -0.0; 5.0 5.0 5.0]

    matrices = generate_design_matrices(3, 2, RandomSample(), 2, Float32)
    @test length(matrices) == 2
    @test all(size(matrix) == (2, 3) for matrix in matrices)
    @test all(eltype(matrix) == Float32 for matrix in matrices)

    bounded_matrices = generate_design_matrices(
        3, [-2.0, 4.0], [2.0, 6.0], RandomSample(), 2
    )
    @test all(all([-2.0, 4.0] .<= matrix .<= [2.0, 6.0]) for matrix in bounded_matrices)
end

module QuasiMonteCarloDistributionsExt

using QuasiMonteCarlo
import Distributions

"""
```julia
sample(n::Integer, lb::T, ub::T, D::Distributions.Sampleable, T = eltype(D))
sample(n::Integer,
    lb::T,
    ub::T,
    D::Distributions.Sampleable) where {T <: Union{Base.AbstractVecOrTuple, Number}}
```

Return a point set from a distribution `D`:

  - `n` is the number of points to sample.
  - `D` is a `Distributions.Sampleable` from Distributions.jl.
    The point set is in a `d`-dimensional unit box `[0, 1]^d`.
    If the bounds are specified instead of just `d`, the sample is transformed (translation + scaling) into a box `[lb, ub]` where:
  - `lb` is the lower bound for each variable. Its length fixes the dimensionality of the sample.
  - `ub` is the upper bound. Its dimension must match `length(lb)`.
"""
function QuasiMonteCarlo.sample(
        n::Integer,
        d::Integer,
        D::Distributions.Sampleable,
        T = eltype(D)
    )
    @assert n > 0 QuasiMonteCarlo.ZERO_SAMPLES_MESSAGE
    x = [[rand(D) for j in 1:d] for i in 1:n]
    return reduce(hcat, x)
end

"""
```julia
sample(n::Integer, d::Integer, S::Distributions.Sampleable, T = Float64)
sample(n::Integer,
    lb::T,
    ub::T,
    S::Distributions.Sampleable) where {T <: Union{Base.AbstractVecOrTuple, Number}}
```

Return a QMC point set where:

  - `n` is the number of points to sample.
  - `S` is the quasi-Monte Carlo sampling strategy.
    The point set is in a `d`-dimensional unit box `[0, 1]^d`.
    If the bounds are specified, the sample is transformed (translation + scaling) into a box `[lb, ub]` where:
  - `lb` is the lower bound for each variable. Its length fixes the dimensionality of the sample.
  - `ub` is the upper bound. Its dimension must match `length(lb)`.

In the first method the type of the point set is specified by `T` while in the second method the output type is inferred from the bound types.
"""
function QuasiMonteCarlo.sample(
        n::Integer, lb::T, ub::T,
        S::D
    ) where {
        T <: Union{Base.AbstractVecOrTuple, Number},
        D <: Distributions.Sampleable,
    }
    QuasiMonteCarlo._check_sequence(lb, ub, n)
    lb = float.(lb)
    ub = float.(ub)
    out = QuasiMonteCarlo.sample(n, length(lb), S, eltype(lb))
    return (ub .- lb) .* out .+ lb
end

function QuasiMonteCarlo.DesignMatrix(
        N,
        d,
        D::Distributions.Sampleable,
        num_mats,
        T = Float64
    )
    X = QuasiMonteCarlo.initialize(N, d, D, T)
    return QuasiMonteCarlo.DistributionDesignMat(X, D, num_mats)
end

function QuasiMonteCarlo.initialize(n, d, D::Distributions.Sampleable, T = Float64)
    # Generate unrandomized sequence
    X = zeros(T, d, n)
    return X
end

end

using Documenter, QuasiMonteCarlo

include("pages.jl")

makedocs(
    sitename = "QuasiMonteCarlo.jl",
    authors = "Chris Rackauckas",
    modules = [QuasiMonteCarlo],
    clean = true, doctest = true, linkcheck = true,
    checkdocs = :exports,
    linkcheck_ignore = [
        "https://www.sciencedirect.com/science/article/pii/S0010465509003087",
        "https://artowen.su.domains/mc/qmcstuff.pdf",
    ],
    format = Documenter.HTML(
        assets = ["assets/favicon.ico"],
        canonical = "https://docs.sciml.ai/QuasiMonteCarlo/stable/"
    ),
    pages = pages
)

deploydocs(
    repo = "github.com/SciML/QuasiMonteCarlo.jl.git";
    push_preview = true
)

# upper-triangular Pascal matrix--needed to generate Faure points
function pascal_mat(dimension::I, base = Inf) where {I <: Integer}
    pascal = UpperTriangular(ones(I, dimension, dimension))
    @inbounds for i in 2:dimension
        for j in 2:i
            pascal[j, i] = (pascal[j - 1, i - 1] + pascal[j, i - 1]) % base
        end
    end
    return pascal
end

# raise a Pascal matrix to a given power.
@fastmath function pascal_power!(
        result::UpperTriangular, pascal::UpperTriangular,
        power::Integer, base::Integer
    )
    @inbounds @simd for idx in eachindex(pascal)
        i, j = Tuple(idx)
        i ≤ j ? (result[idx] = powermod(power, j - i, base) * pascal[idx]) : result[idx]
    end
    return result
end

"""
    FaureSample(R::RandomizationMethod = NoRand()) <: DeterministicSamplingAlgorithm

A Faure low-discrepancy sequence.

Faure-distributed samples cover all dimensions evenly, using the same set of points for all
variables, up to ordering.

When scrambled, randomized Faure sequences provide worst-case guarantees that variance will
be at most `exp(1) ≈ 2.718` times greater than for a purely Monte Carlo integral. However,
they are much less efficient than the Sobol sequence at integrating functions with low
effective dimension (functions where the first few inputs dominate the evaluation).

The Faure sequence in dimension `s` forms a `(0, s)`-sequence with base `b = nextprime(s)`.

A Faure sequence must have length `k * base^s` with `k < base < 1`.

References:
Faure, H. (1982). Discrépance de suites associées à un système de numération (en dimension s). *Acta Arith.*, 41, 337-351.
Owen, A. B. (1997). Monte Carlo variance of scrambled net quadrature. *SIAM Journal on Numerical Analysis*, 34(5), 1884-1910.
"""
Base.@kwdef struct FaureSample <: DeterministicSamplingAlgorithm
    R::RandomizationMethod = NoRand()
end

@fastmath function sample(
        n::Integer, dimension::Integer, S::FaureSample, T = Float64;
        skipchecks = false
    )
    base = nextprime(dimension)
    n_digits = ceil(Int, log(base, n))
    power = n_digits - 1

    if !skipchecks && (n % prevpow(base, n) ≠ 0)
        n -= (n % base^power)
        throw(
            ArgumentError(
                "Invalid sample size: Faure sequences must be multiples of `base^power`. " *
                    "Try $n or $(n + base^power) instead."
            )
        )
    end

    return randomize(_faure_samples(n, n_digits, dimension, T), S.R)
end

@fastmath @views function _faure_samples(
        n_samples::I, n_digits::I, dimension::I,
        ::Type{F} = Float64
    ) where {I <: Integer, F}
    base = nextprime(dimension)
    inv_base = inv(base)

    # Upper triangular Pascal matrix
    pascal = pascal_mat(n_digits, base)
    # we multiply by powers of a Pascal matrix to generate it. preallocating:
    permutation = similar(pascal)
    # preallocate space for Faure points and a vector of digits
    faure = zeros(F, dimension, n_samples)
    digit_counter = zeros(I, n_digits)
    dgs = copy(digit_counter)
    for dim_idx in 1:dimension
        digit_counter .= base - 1
        dim_idx == 1 || pascal_power!(permutation, pascal, dim_idx - 1, base)
        # each dimension of a Faure sequence is a permuted van der Corput (vdc) sequence
        vdc = faure[dim_idx, :]
        for sample_idx in eachindex(vdc)
            # increment digit counter by 1
            _base_sum!(digit_counter, base)
            dgs .= digit_counter
            # permute later dimensions using powers of a Pascal matrix
            if dim_idx ≠ 1
                dgs .= (permutation * dgs) .% base
            end
            vdc[sample_idx] = (evalpoly(inv_base, dgs) + inv(2base^n_digits)) * inv_base
        end
    end
    return faure
end

# @fastmath @views function _base_sum!(dgs::AbstractVector, base::Integer)
#     dgs[1] = one(eltype(dgs)) + dgs[1]
#     if dgs[1] == base
#         dgs[1] = zero(eltype(dgs))
#         if length(dgs) ≠ 1  # ignore overflows
#             _base_sum!(dgs[2:end], base)
#         end
#     end
# end

# * The scrambling codes were first inspired from Owen's `R` implementation that can be found [here](https://artowen.su.domains/code/rsobol.R). * #
#TODO the typing could probably improved, resulting in more type stable (important for QMC computation to be able to use Float32, Float64, Rational, ... for points, and Int64, Int32, Int16 etc for bits etc.)

"""
```julia
ScrambleMethod <: RandomizationMethod
```

A scramble method needs at least the scrambling base `b`, the number of "bits" to use `pad` (`pad=32` is the default) and an RNG (`rng = Random.TaskLocalRNG()` by default).
The scramble methods implementer are

  - `DigitalShift`.
  - `OwenScramble`: Nested Uniform Scramble which was introduced in Owen (1995).
  - `MatousekScramble`: Linear Matrix Scramble which was introduced in Matousek (1998).
"""
abstract type ScrambleMethod <: RandomizationMethod end

"""
    randomize(x, R::ScrambleMethod)

Return a scrambled version of `x`.
The scramble methods implemented are

  - `DigitalShift`.
  - `OwenScramble`: Nested Uniform Scramble which was introduced in Owen (1995).
  - `MatousekScramble`: Linear Matrix Scramble which was introduced in Matousek (1998).
"""
function randomize(x, R::ScrambleMethod)
    random_x = permutedims(copy(x))
    randomize!(random_x, permutedims(x), R)
    return permutedims(random_x)
end

"""
```julia
OwenScramble <: ScrambleMethod
```

Nested Uniform Scramble aka Owen's scramble.

`randomize(x, R::OwenScramble)` returns a scrambled version of `x`.
The scramble method is Nested Uniform Scramble which was introduced in Owen (1995).
`pad` is the number of bits used for each point. One needs `pad ≥ log(base, n)`.

References: Owen, A. B. (1995). Randomly permuted (t, m, s)-nets and (t, s)-sequences. In Monte Carlo and Quasi-Monte Carlo Methods in Scientific Computing: Proceedings of a conference at the University of Nevada, Las Vegas, Nevada, USA, June 23–25, 1994 (pp. 299-317). Springer New York.
"""
Base.@kwdef struct OwenScramble{I <: Integer} <: ScrambleMethod
    base::I
    pad::I = 32
    rng::AbstractRNG = Random.TaskLocalRNG()
end

function randomize!(
        random_points::AbstractMatrix{T},
        points::AbstractMatrix{T}, R::OwenScramble
    ) where {T <: Real}
    @assert size(points) == size(random_points)
    b = R.base
    unrandomized_bits = unif2bits(points, b, pad = R.pad)
    random_bits = similar(unrandomized_bits)
    indices = which_permutation(unrandomized_bits, b)
    randomize_bits!(random_bits, unrandomized_bits, indices, R)
    for i in CartesianIndices(random_points)
        random_points[i] = bits2unif(T, @view(random_bits[:, i]), b)
    end
    return
end

"""
    randomize_bits!(random_bits::AbstractArray{T, 3}, origin_bits::AbstractArray{T, 3}, R::ScrambleMethod) where {T <: Integer}

In place version of a `OwenScramble` (Nested Uniform Scramble) for the "bit" array.
This is faster to use this functions for multiple scramble of the same array (use `generate_design_matrices`).
"""
function randomize_bits!(
        random_bits::AbstractArray{T, 3},
        origin_bits::AbstractArray{T, 3},
        indices::AbstractArray{F, 3},
        R::OwenScramble
    ) where {T <: Integer, F <: Integer}
    # in place nested uniform Scramble.
    #
    m, n, d = size(indices)
    b = R.base
    rng = R.rng
    pad = size(random_bits, 1)
    @assert m ≥ 1 "We need m ≥ 1" # m=0 causes awkward corner case below.

    for s in 1:d
        theperms = getpermset(rng, m, b)         # Permutations to apply to bits 1:m
        for k in 1:m                             # Here is where we want m > 0 so the loop works ok
            @views random_bits[k, :, s] .= (
                origin_bits[k, :, s] .+
                    theperms[k, indices[k, :, s]]
            ) .%
                b   # permutation by adding a bit modulo b
        end
    end

    # Paste in random entries for bits after m'th one
    return if pad > m
        # random_bits[(m + 1):pad, :, :] = rand(rng, 0:(b - 1), n * d * (pad - m))
        rand!(rng, @view(random_bits[(m + 1):pad, :, :]), 0:(b - 1))
    end
end

function getpermset(rng::AbstractRNG, m::Integer, b::I) where {I <: Integer}
    # Get b^(k-1) random binary permutations for k=1 ... m
    # m will ordinarily be m when there are n=b^m points
    #
    y = zeros(I, m, b^(m - 1))
    for k in 1:m
        nₖ = b^(k - 1)
        y[k, 1:nₖ] = rand(rng, 0:(b - 1), nₖ)
    end
    return y
end

getpermset(m::Integer, b::Integer) = getpermset(Random.TaskLocalRNG(), m, b)

"""
    which_permutation(bits::AbstractArray{<:Integer,3}, b)

This function is used in Nested Uniform Scramble.
It assigns for each point (in every dimension) `m` number corresponding to its location on the slices 1, 1/b, 1/b², ..., 1/bᵐ⁻¹ of the axes [0,1[.
This also can be used to verify some equidistribution prorepreties.
Here we create the `indices` array `m`, and not `pad`. Indeed `(t,m,d)-net` in base `b` are scrambled up to the `1/bᵐ` component.
Higher order components are just used i.i.d. `Uₖ ∼ 𝐔({0:b-1})` in `owen_scramble_bit!`.
"""
function which_permutation(bits::AbstractArray, b::I) where {I <: Integer}
    n, d = size(bits)[2:end]
    m = logi(b, n)

    indices = zeros(I, m, n, d)
    for j in axes(bits, 3)
        which_permutation!(@view(indices[:, :, j]), bits[:, :, j], b)
    end
    return indices
end

function which_permutation!(
        indices::AbstractMatrix{<:Integer},
        bits::AbstractMatrix{<:Integer}, b::Integer
    )
    @assert size(indices)[2:end] == size(bits)[2:end] "You need size(indices) = $(size(indices)) equal size(bits) = $(size(bits))"
    indices[1, :] .= 0 # same permutation for all observations i
    for i in axes(indices, 2)                     # Here is where we want m > 0 so the loop works ok
        for k in axes(indices, 1)[2:end]
            indices[k, i] = bits2int(@view(bits[1:(k - 1), i]), b) # index of which perms to use at bit k for each i
        end
    end
    return indices .+= 1 # array indexing starts at 1
end

function randomize!(
        random_points::AbstractMatrix{T},
        points::AbstractMatrix{T}, R::ScrambleMethod
    ) where {T <: Real}
    @assert size(points) == size(random_points)
    b = R.base
    unrandomized_bits = unif2bits(points, b, pad = R.pad)
    random_bits = similar(unrandomized_bits)
    randomize_bits!(random_bits, unrandomized_bits, R)
    for i in CartesianIndices(random_points)
        random_points[i] = bits2unif(T, @view(random_bits[:, i]), b)
    end
    return
end

"""
```julia
MatousekScramble <: ScrambleMethod
```

Linear Matrix Scramble aka Matousek's scramble.

`randomize(x, R::MatousekScramble)` returns a scrambled version of `x`.
The scramble method is Linear Matrix Scramble which was introduced in Matousek (1998).
`pad` is the number of bits used for each point. One needs `pad ≥ log(base, n)`.

References: Matoušek, J. (1998). On thel2-discrepancy for anchored boxes. Journal of Complexity, 14(4), 527-556.
"""
Base.@kwdef struct MatousekScramble{I <: Integer} <: ScrambleMethod
    base::I
    pad::I = 32
    rng::AbstractRNG = Random.TaskLocalRNG()
end

#? Weird it should be faster than nested uniform Scramble but here it is not at all.-> look for other implementation and paper
"""
    randomize_bits!(random_bits::AbstractArray{T, 3}, origin_bits::AbstractArray{T, 3}, R::ScrambleMethod) where {T <: Integer}

In place version of a ScrambleMethod (`MatousekScramble` or `DigitalShift`) for the "bit" array.
This is faster to use this functions for multiple scramble of the same array (use `generate_design_matrices`).
"""
function randomize_bits!(
        random_bits::AbstractArray{T, 3},
        origin_bits::AbstractArray{T, 3},
        R::MatousekScramble
    ) where {T <: Integer}
    # https://statweb.stanford.edu/~owen/mc/ Chapter 17.6 around equation (17.15).
    #
    pad, n, d = size(origin_bits)
    b = R.base
    rng = R.rng
    m = logi(b, n)
    @assert m ≥ 1 "We need m ≥ 1" # m=0 causes awkward corner case below.  Caller handles that case specially.

    for s in 1:d
        # Permutations matrix and shift to apply to bits 1:m
        matousek_M, matousek_C = getmatousek(rng, m, b)

        # xₖ = (∑ₗ Mₖₗ aₗ + Cₖ) mod b where xₖ is the k element in base b
        # matousek_M (m×m) * origin_bits (m×n) .+ matousek_C (m×1)
        @views random_bits[1:m, :, s] .= (
            matousek_M * origin_bits[1:m, :, s] .+
                matousek_C
        ) .% b
    end

    # Paste in random entries for bits after m'th one
    return if pad > m
        # random_bits[(m + 1):pad, :, :] = rand(rng, 0:(b - 1), n * d * (pad - m))
        rand!(rng, @view(random_bits[(m + 1):pad, :, :]), 0:(b - 1))
    end
end

"""
    getmatousek(rng::AbstractRNG, m::Integer, b::Integer)

Generate the Matousek linear scramble in base b for one of the d components
It produces a m x m bit matrix matousek_M and a length m bit vector matousek_C
"""
function getmatousek(rng::AbstractRNG, m::Integer, b::I) where {I <: Integer}
    matousek_M = LowerTriangular(zeros(I, m, m)) + Diagonal(rand(rng, 1:(b - 1), m)) # Mₖₖ ∼ U{1, ⋯, b-1}
    matousek_C = rand(rng, 0:(b - 1), m)
    for i in 2:m
        for j in 1:(i - 1)
            matousek_M[i, j] = rand(rng, 0:(b - 1))
        end
    end
    return matousek_M, matousek_C
end

getmatousek(m::Integer, b::Integer) = getmatousek(Random.TaskLocalRNG(), m, b)

"""
```julia
DigitalShift <: ScrambleMethod
```

Digital shift.
`randomize(x, R::DigitalShift)` returns a scrambled version of `x`.

The scramble method is Digital Shift.
It scrambles each coordinate in base `b` as `yₖ = (xₖ + Uₖ) mod b` where `Uₖ ∼ 𝕌({0:b-1})`.
`U` is the same for every point `points` but i.i.d. along every dimension.
"""
Base.@kwdef struct DigitalShift{I <: Integer} <: ScrambleMethod
    base::I
    pad::I = 32
    rng::AbstractRNG = Random.TaskLocalRNG()
end

function randomize_bits!(
        random_bits::AbstractArray{T, 3},
        origin_bits::AbstractArray{T, 3},
        R::DigitalShift
    ) where {T <: Integer}
    # https://statweb.stanford.edu/~owen/mc/ Chapter 17.6 around equation (17.15).
    #
    pad, n, d = size(origin_bits)
    b = R.base
    rng = R.rng
    m = logi(b, n)
    @assert m ≥ 1 "We need m ≥ 1" # m=0 causes awkward corner case below.  Caller handles that case specially.

    for s in 1:d
        # Permutations matrix and shift to apply to bits 1:m
        DS = rand(rng, 0:(b - 1), m)

        # xₖ = (aₖ + Cₖ) mod b where xₖ is the k element in base b
        # origin_bits (m×n) .+ DS (m×1)
        @views random_bits[1:m, :, s] .= (origin_bits[1:m, :, s] .+ DS) .% b
    end

    # Paste in random entries for bits after m'th one
    return if pad > m
        # random_bits[(m + 1):pad, :, :] = rand(rng, 0:(b - 1), n * d * (pad - m))
        rand!(rng, @view(random_bits[(m + 1):pad, :, :]), 0:(b - 1))
    end
end

"""
    Shift(; rng = Random.TaskLocalRNG()) <: RandomizationMethod

Cranley-Patterson rotation.

References: Cranley, R., & Patterson, T. N. (1976). Randomization of number theoretic methods for multiple integration. SIAM Journal on Numerical Analysis, 13(6), 904-914.
"""
Base.@kwdef @concrete struct Shift <: RandomizationMethod
    rng::AbstractRNG = Random.TaskLocalRNG()
end

"""
    randomize(x, R::Shift)

Cranley Patterson Rotation i.e. `y = (x .+ U) mod 1` where `U ∼ 𝕌([0,1]ᵈ)` and `x` is a `d×n` matrix
"""
function randomize(x, R::Shift)
    y = copy(x)
    shift!(R.rng, y)
    return y
end

function randomize!(x, R::Shift)
    return shift!(R.rng, x)
end

function shift!(rng::AbstractRNG, points::AbstractMatrix{T}) where {T <: Real}
    d = size(points, 1)
    U = zeros(T, d)
    return shift!(rng, points, U)
end

function shift!(points::AbstractMatrix{T}, U::AbstractVector{T}) where {T <: Real}
    return shift!(Random.TaskLocalRNG(), points, U)
end

function shift!(
        rng::AbstractRNG, points::AbstractMatrix{T},
        U::AbstractVector{T}
    ) where {T <: Real}
    rand!(rng, U)
    for i in axes(points, 2)
        points[:, i] += U
    end
    return points[:] = frac.(points)
end

frac(y) = y - floor(y)

"""
    RandomizedHaltonSample(; rng = Random.TaskLocalRNG()) <: RandomSamplingAlgorithm

Create a randomized Halton sequence.

References:
Owen, A. (2017). *A randomized Halton algorithm in R*. https://doi.org/10.48550/arXiv.1706.02808
"""
Base.@kwdef @concrete struct RandomizedHaltonSample <: RandomSamplingAlgorithm
    rng::AbstractRNG = Random.TaskLocalRNG()
end

function sample(n::Integer, d::Integer, S::RandomizedHaltonSample, T = Float64)
    _check_sequence(n)
    bases = nextprimes(one(n), d)
    halton_seq = Matrix{T}(undef, d, n)

    ind = collect(1:n)
    for i in 1:d
        halton_seq[i, :] = randradinv(ind, S.rng, bases[i])
    end
    return halton_seq
end

function randradinv(ind::Vector{Int}, rng::AbstractRNG, b::Int = 2)
    b2r = 1 / b
    ans = ind .* 0
    res = ind

    base_ind = 1:b

    while (1 - b2r < 1)
        dig = res .% b
        perm = shuffle(rng, base_ind) .- 1
        pdig = perm[convert.(Int, dig .+ 1)]
        ans = ans .+ pdig .* b2r
        b2r = b2r / b
        res = (res .- dig) ./ b
    end
    return ans
end

"""
    SobolSample(R::RandomizationMethod = NoRand()) <: DeterministicSamplingAlgorithm

Samples taken from Sobol's base-2 sequence.
"""
Base.@kwdef @concrete struct SobolSample <: DeterministicSamplingAlgorithm
    R::RandomizationMethod = NoRand()
end

function sample(n::Integer, d::Integer, S::SobolSample, T = Float64)
    if n < 0
        throw(ArgumentError("number of samples must be non-negative"))
    end

    seq = Matrix{T}(undef, d, n)
    if n == 0
        return seq
    end

    # Use function barrier since `Sobol.SobolSeq(d)` can't be inferred
    return _sample!(seq, Sobol.SobolSeq(d), S.R)
end

function _sample!(seq::AbstractMatrix, s::Sobol.SobolSeq, R::RandomizationMethod)
    n = size(seq, 2)
    skip(s, n)
    for x in eachcol(seq)
        Sobol.next!(s, x)
    end
    return randomize(seq, R)
end

abstract type AbstractDesignMatrix end

# Make an iterator so that we can do "for X in DesignMatrix(...)"
Base.length(s::AbstractDesignMatrix) = s.count
function Base.iterate(s::AbstractDesignMatrix, state = 1)
    return state > s.count ? nothing : (next!(s), state + 1)
end

"""
    OwenDesignMat{T<:Real, I<:Integer, F<:Integer} <: AbstractDesignMatrix

Create an Owen scrambling iterator for doing multiple i.i.d. [`OwenScrambling`](@ref) randomization.
One can use the common[`DesignMatrix`](@ref) interface to create the iterator.
"""
mutable struct OwenDesignMat{T <: Real, I <: Integer, F <: Integer} <: AbstractDesignMatrix
    X::Array{T, 2} #array of size (N, d)
    random_bits::Array{I, 3} #array of size (pad, N, d)
    bits::Array{I, 3} #array of size (pad, N, d)
    indices::Array{F, 3} #array of size (m, N, d)
    R::OwenScramble
    count::Int
end

"""
    ScrambleDesignMat{T<:Real, I<:Integer} <: AbstractDesignMatrix

Create a scrambling iterator (Digital Shift or Matousek depending on the `R` field) for doing multiple i.i.d. [`DigitalShift`](@ref) or [`MatousekScrambling`](@ref) randomization.
One can use the common[`DesignMatrix`](@ref) interface to create the iterator.
"""
mutable struct ScrambleDesignMat{T <: Real, I <: Integer} <: AbstractDesignMatrix
    X::Array{T, 2} #array of size (N, d)
    random_bits::Array{I, 3} #array of size (pad, N, d)
    bits::Array{I, 3} #array of size (pad, N, d)
    R::ScrambleMethod
    count::Int
end

"""
    ShiftDesignMat{T<:Real} <: AbstractDesignMatrix

Create a Shift iterator for doing multiple i.i.d [`Shift`](@ref) randomization.
One can use the common[`DesignMatrix`](@ref) interface to create the iterator.
"""
mutable struct ShiftDesignMat{T <: Real} <: AbstractDesignMatrix
    X::Array{T, 2} #array of size (N, d)
    R::Shift
    count::Int
end

"""
    DistributionDesignMat{T<:Real} <: AbstractDesignMatrix

Create an iterator for multiple distribution randomization. The distribution is chosen with the field `D`.
This is equivalent to using `rand!(D, X)` for some matrix `X`.
One can use the common[`DesignMatrix`](@ref) interface to create the iterator.
"""
mutable struct DistributionDesignMat{T <: Real, T2} <: AbstractDesignMatrix
    X::Array{T, 2} #array of size (N, d)
    D::T2 #::Distributions.Sampleable
    count::Int
end

"""
    RandomDesignMat{T<:Real} <: AbstractDesignMatrix

Create an iterator for multiple uniform randomization. This it similar to [`DistributionDesignMat`](@ref) with the field `D = Uniform()`
One can use the common[`DesignMatrix`](@ref) interface to create the iterator.
"""
mutable struct RandomDesignMat{T <: Real} <: AbstractDesignMatrix
    X::Array{T, 2} #array of size (N, d)
    count::Int
end

Base.eltype(::Type{OwenDesignMat{T, I, F}}) where {T, I, F} = Matrix{T}
Base.eltype(::Type{ScrambleDesignMat{T, I}}) where {T, I} = Matrix{T}
Base.eltype(::Type{ShiftDesignMat{T}}) where {T} = Matrix{T}
Base.eltype(::Type{DistributionDesignMat{T}}) where {T} = Matrix{T}
Base.eltype(::Type{RandomDesignMat{T}}) where {T} = Matrix{T} # TODO one could create a type for AbstractDistribution to include RandomDesignMat and DistributionDesignMat

"""
```julia
DesignMatrix(n, d, sample_method::DeterministicSamplingAlgorithm, num_mats, T = Float64)
```

Create an iterator for doing multiple i.i.d. randomization over QMC sequences where

  - `num_mats` is the length of the iterator
  - `n` is the number of points to sample.
  - `d` is the dimensionality of the point set in `[0, 1)ᵈ`,
  - `sample_method` is the quasi-Monte Carlo sampling strategy used to create a deterministic point set `out`.
  - `T` is the `eltype` of the point sets. For some QMC methods (Faure, Sobol) this can be `Rational`
    It is now compatible with all scrambling methods and shifting. One can also use it with `Distributions.Sampleable` or `RandomSample`.
"""
function DesignMatrix(
        N, d, S::DeterministicSamplingAlgorithm, num_mats::Integer, T::DataType = Float64
    )
    return DesignMatrix(N, d, S, S.R, num_mats, T)
end

function DesignMatrix(
        N,
        d,
        S::DeterministicSamplingAlgorithm,
        R::OwenScramble,
        num_mats::Integer,
        T::DataType = Float64
    )
    X, random_bits, bits, indices = initialize(N, d, S, R, T)
    return OwenDesignMat(X, random_bits, bits, indices, R, num_mats)
end

function DesignMatrix(
        N,
        d,
        S::DeterministicSamplingAlgorithm,
        R::ScrambleMethod,
        num_mats::Integer,
        T = Float64
    )
    X, random_bits, bits = initialize(N, d, S, R, T)
    return ScrambleDesignMat(X, random_bits, bits, R, num_mats)
end

function DesignMatrix(
        N,
        d,
        S::DeterministicSamplingAlgorithm,
        R::Shift,
        num_mats,
        T::DataType = Float64
    )
    X = initialize(N, d, S, R, T)
    return ShiftDesignMat(X, R, num_mats)
end

function DesignMatrix(N, d, D::RandomSample, num_mats, T::DataType = Float64)
    X = initialize(N, d, D, T)
    return RandomDesignMat(X, num_mats)
end

next!(DM::OwenDesignMat) = scramble!(DM.X, DM.random_bits, DM.bits, DM.indices, DM.R)
next!(DM::ScrambleDesignMat) = scramble!(DM.X, DM.random_bits, DM.bits, DM.R)
next!(DM::ShiftDesignMat) = randomize!(DM.X, DM.R)
next!(DM::DistributionDesignMat) = rand!(DM.D, DM.X)
next!(DM::RandomDesignMat) = rand!(DM.X)

## OwenScramble
function initialize(n, d, sampler, R::OwenScramble, T::DataType = Float64)
    # Generate unrandomized sequence
    no_rand_sampler = @set sampler.R = NoRand()
    points = permutedims(sample(n, d, no_rand_sampler, T))

    b = R.base
    bits = unif2bits(points, b, pad = R.pad)
    random_bits = similar(bits)
    random_points = similar(points)
    indices = which_permutation(bits, R.base)
    return random_points, random_bits, bits, indices
end

function scramble!(
        random_points::AbstractArray{T},
        random_bits,
        bits,
        indices,
        R::OwenScramble
    ) where {T <: Real}
    randomize_bits!(random_bits, bits, indices, R)
    for i in CartesianIndices(random_points)
        random_points[i] = bits2unif(T, @view(random_bits[:, i]), R.base)
    end
    return permutedims(random_points)
end

## Other scramble

function initialize(n, d, sampler, R::ScrambleMethod, T::DataType = Float64)
    # Generate unrandomized sequence
    no_rand_sampler = @set sampler.R = NoRand()
    points = permutedims(sample(n, d, no_rand_sampler, T))

    b = R.base
    bits = unif2bits(points, b, pad = R.pad)
    random_bits = similar(bits)
    random_points = similar(points)
    return random_points, random_bits, bits
end

function scramble!(
        random_points::AbstractArray{T},
        random_bits,
        bits,
        R::ScrambleMethod
    ) where {T <: Real}
    randomize_bits!(random_bits, bits, R)
    for i in CartesianIndices(random_points)
        random_points[i] = bits2unif(T, @view(random_bits[:, i]), R.base)
    end
    return permutedims(random_points)
end

## Shift
function initialize(n, d, sampler, R::Shift, T::DataType = Float64)
    # Generate unrandomized sequence
    no_rand_sampler = @set sampler.R = NoRand()
    points = sample(n, d, no_rand_sampler, T)
    return points
end

## Distribution
function initialize(n, d, D::RandomSample, T::DataType = Float64)
    # Generate unrandomized sequence
    X = zeros(T, d, n)
    return X
end

# generate_design_matrices

## Generic function

"""
    generate_design_matrices(n, d, sampler, num_mats, T = Float64)
    generate_design_matrices(n, lb, ub, sampler, num_mats = 2)

Generate multiple point-set matrices with `sampler`.

## Arguments

  - `n`: Positive number of points in each generated matrix.
  - `d`: Positive dimension of the unit box. This form returns matrices of size
    `(d, n)` with elements in `[0, 1]`.
  - `lb`: Collection of lower bounds. Its length determines the dimension.
  - `ub`: Collection of upper bounds with the same length as `lb`.
  - `sampler`: Concrete [`SamplingAlgorithm`](@ref) used to construct each
    point set.
  - `num_mats`: Number of matrices to generate.

## Optional Positional Arguments

  - `T = Float64`: Element type of the unit-box matrices.

## Returns

A vector of `num_mats` matrices. Each unit-box matrix has size `(d, n)`. The
bounds form maps every coordinate to its corresponding interval `[lb[i], ub[i]]`.

## Examples

```jldoctest
julia> using QuasiMonteCarlo

julia> matrices = generate_design_matrices(4, 2, RandomSample(), 3);

julia> length(matrices)
3

julia> all(size(matrix) == (2, 4) for matrix in matrices)
true
```

## Developer Notes

This function builds on the public [`sample`](@ref) contract. New sampling
algorithms should extend `sample`; they should not add methods to
`generate_design_matrices`.
"""
function generate_design_matrices(
        n, d, sampler::DeterministicSamplingAlgorithm, num_mats::Integer,
        T::DataType = Float64
    )
    return generate_design_matrices(n, d, sampler, sampler.R, num_mats, T)
end

function generate_design_matrices(
        n, d, sampler::RandomSamplingAlgorithm, num_mats::Integer,
        T::DataType = Float64
    )
    return [sample(n, d, sampler, T) for j in 1:num_mats]
end

function generate_design_matrices(
        n, lb, ub, sampler,
        num_mats = 2
    )
    if n <= 0
        throw(ZeroSamplesError())
    end
    @assert length(lb) == length(ub)

    # Generate a vector of num_mats independent "randomized" version of the QMC sequence
    out = generate_design_matrices(n, length(lb), sampler, num_mats, eltype(lb))

    # Scaling
    for j in eachindex(out)
        out[j] = (ub .- lb) .* out[j] .+ lb
    end
    return out
end

## NoRand()

"""
    generate_design_matrices(n, d, sampler, R::NoRand, num_mats, T = Float64)

`R = NoRand()` produces `num_mats` matrices each containing a different deterministic point set in `[0, 1)ᵈ`.
Note that this is an ad hoc way to produce i.i.d sequence as it creates a deterministic point in dimension `d × num_mats` and split it in `num_mats` point set of dimension `d`.
This does not have any QMC garantuees.
"""
function generate_design_matrices(
        n, d, sampler, R::NoRand, num_mats::Integer, T::DataType = Float64
    )
    out = sample(n, num_mats * d, sampler, T)
    @warn "The `generate_design_matrices(n, d, sampler, R = NoRand(), num_mats)` method does not produces true and independent QMC matrices, see [this doc warning](https://docs.sciml.ai/QuasiMonteCarlo/stable/design_matrix/) for more context.
    Prefer using randomization methods such as `R = Shift()`, `R = MatousekScrambling()`, etc., see [documentation](https://docs.sciml.ai/QuasiMonteCarlo/stable/randomization/)"
    return [out[(j * d + 1):((j + 1) * d), :] for j in 0:(num_mats - 1)]
end

function generate_design_matrices(
        n,
        d,
        sampler,
        R::RandomizationMethod,
        num_mats::Integer,
        T::DataType = Float64
    )
    return collect(DesignMatrix(n, d, sampler, R, num_mats, T))
end

# """
# ```julia
# struct SectionSample{T} <: SamplingAlgorithm
# ```
# `SectionSample(x0, sampler)` where `sampler` is any sampler above and `x0` is a vector of either `NaN` for a free dimension or some scalar for a constrained dimension.
# """
# struct SectionSample{T} <: SamplingAlgorithm
#     x0::Vector{T}
#     sa::SamplingAlgorithm
# end

# """
#     SectionSample{T}(x0, sa)

# `SectionSample(x0, sampler)` where `sampler` is any sampler above and `x0` is a vector of either `NaN` for a free dimension or some scalar for a constrained dimension.
# """
# struct SectionSample{R<:Real,I<:Integer,VR<:AbstractVector{R},VI<:AbstractVector{I}} <: SamplingAlgorithm
#     x0::VR
#     sa::SamplingAlgorithm
#     fixed_dims::VI
# end

# fixed_dimensions(section_sampler::SectionSample)::Vector{Int64} = findall(x -> x == false,
#                                                                           isnan.(section_sampler.x0))

# free_dimensions(section_sampler::SectionSample)::Vector{Int64} = findall(x -> x == true,
#                                                                          isnan.(section_sampler.x0))

# """
#     sample(n,lb,ub,K::SectionSample)

# Returns Tuples constrained to a section.
# In surrogate-based identification and control, optimization can alternate between unconstrained sampling in the full-dimensional parameter space, and sampling constrained on specific sections (e.g. a planes in a 3D volume),
# A SectionSample allows sampling and optimizing on a subset of 'free' dimensions while keeping 'fixed' ones constrained.
# The sampler is defined as in e.g.
# `section_sampler_y_is_10 = SectionSample([NaN64, NaN64, 10.0, 10.0], UniformSample())`
# where the first argument is a Vector{T} in which numbers are fixed coordinates and `NaN`s correspond to free dimensions, and the second argument is a SamplingAlgorithm which is used to sample in the free dimensions.
# """
# function sample(n::Integer, lb::Union{Number, Tuple, AbstractVector},
#                 ub::Union{Number, Tuple, AbstractVector}, section_sampler::SectionSample)
#     if n <= 0
#         throw(ZeroSamplesError())
#     end
#     if !check_bounds(lb, ub)
#         throw(UbLbWrong())
#     end
#     if lb isa Number
#         if isnan(section_sampler.x0[1])
#             return sample(n, lb, ub, section_sampler.sa)
#         else
#             return fill(section_sampler.x0[1], n)
#         end
#     else
#         d_free = free_dimensions(section_sampler)
#         new_samples = sample(n, lb[d_free], ub[d_free], section_sampler.sa)
#         out_as_vec = collect(repeat(section_sampler.x0', n, 1)')
#         for y in 1:size(out_as_vec, 2)
#             for (xi, d) in enumerate(d_free)
#                 out_as_vec[d, y] = new_samples[xi, y]
#             end
#         end
#         return out_as_vec
#     end
# end

# SectionSample(x0::AbstractVector, sa::SamplingAlgorithm) =
#     SectionSample(x0, sa, findall(isnan, x0))

# """
#     SectionSample(n, d, K::SectionSample)

# In surrogate-based identification and control, optimization can alternate between unconstrained sampling in the full-dimensional parameter space, and sampling constrained on specific sections (e.g. planes in a 3D volume).

# `SectionSample` allows sampling and optimizing on a subset of 'free' dimensions while keeping 'fixed' ones constrained.

# The sampler is defined

# `SectionSample([NaN64, NaN64, 10.0, 10.0], UniformSample())`

# where the first argument is a Vector{T} in which numbers are fixed coordinates and `NaN`s correspond to free dimensions, and the second argument is a SamplingAlgorithm which is used to sample in the free dimensions.
# """
# function sample(n::Integer, d::Integer, section_sampler::SectionSample, T=eltype(section_sampler.x0))
#     _check_sequence(n)
#     @assert eltype(section_sampler.x0) == T
#     @assert length(section_sampler.fixed_dims) == d
#     return sample(n, section_sampler)
# end

# @views function sample(n::Integer, section_sampler::SectionSample{T}) where T
#     samples = Matrix{T}(undef, n, length(section_sampler.x0))
#     fixed_dims = section_sampler.fixed_dims
#     samples[:,fixed_dims] .= sample(n, length(fixed_dims), section_sampler.sa, T)
#     return samples
# end

"""
    KroneckerSample(generator::AbstractVector, R::RandomizationMethod = NoRand()) <: DeterministicSamplingAlgorithm

A Kronecker sequence is a point set generated using a vector and equation:
`x[i] = i * generator .% 1`

Where `i` runs from `1` through the sample size `n`. This sequence will be equidistributed
(uniform in the infinite limit) so long as the components of `generator` are linearly
independent over the field of rational numbers.

If no generator is specified, a lattice based on the generalized golden ratio is used; see
`GoldenSample` for more information.

Kronecker sequences are not recommended for use in more than 3 dimensions, as theory on them
is sparse. `LatticeRuleSample` will return rank-1 lattice rules, which behave similarly to
Kronecker sequences but have better properties.

References:
Leobacher, G., & Pillichshammer, F. (2014). *Introduction to quasi-Monte Carlo integration and applications.* Switzerland: Springer International Publishing.
https://link.springer.com/content/pdf/10.1007/978-3-319-03425-6.pdf
"""
Base.@kwdef struct KroneckerSample{V <: Union{AbstractVector, Missing}} <:
    DeterministicSamplingAlgorithm
    generator::V = missing
    R::RandomizationMethod = NoRand()
end

function KroneckerSample(d::Integer, R = NoRand(), T = Float64)
    ratio = harmonious(d, T)
    generator = T[ratio^i for i in 1:d]
    return KroneckerSample(generator, R)
end

function sample(n::Integer, d::Integer, S::KroneckerSample{Missing}, T = Float64)
    return sample(n, d, KroneckerSample(d, S.R, T))
end

function sample(
        n::Integer, d::Integer, k::KroneckerSample{V},
        T
    ) where {V <: AbstractVector}
    @assert eltype(V) == T "Sample type must match generator type."
    return randomize(sample(n, d, k), k.R)
end

function sample(n::Integer, d::Integer, k::KroneckerSample{V}) where {V <: AbstractVector}
    @assert d == length(k.generator) "Dimensions of generator and sample must match."
    return @. mod(k.generator * (1:n)', 1)
end

"""
    GoldenSample()

Generate a quasirandom Kronecker sequence using powers of the generalized golden ratio.

The harmonious, or generalized golden, ratios are defined as the solutions to the equation:
``x^d = x + 1``

Where `d` is the dimension of the sequence. The Golden sequence is then equivalent to
`Kronecker([x^-i for i in 1:d])`.

WARNING: the generalized golden sequence in more than 2 dimensions is purely experimental.
It likely has poor discrepancy in high dimensions, and should not be used without verifying
answers against a better-known quasirandom sequence. Try a rank-1 lattice rule instead.

References:
Roberts, M. (2018). The Unreasonable Effectiveness of Quasirandom Sequences.
*Extreme Learning.*
http://extremelearning.com.au/unreasonable-effectiveness-of-quasirandom-sequences/
"""
GoldenSample(args...; kwargs...) = KroneckerSample(args...; kwargs...)

# generate (inverse) harmonious numbers
@fastmath function harmonious(d::Integer, ::Type{T} = Float64) where {T}
    tol = 2eps(T)
    y_old = one(T)
    # Approximate solution of x^(d+1) = x + 1 (nested radical)
    y = (one(T) + y_old)^inv(d + 1)
    while abs(y - y_old) > tol  # continue until precise enough
        y_old = y
        y = (one(T) + y)^inv(d + 1)
    end
    return inv(y)
end

"""
    HaltonSample(R::RandomizationMethod = NoRand()) <: DeterministicSamplingAlgorithm

Create a Halton sequence.
"""
Base.@kwdef @concrete struct HaltonSample <: DeterministicSamplingAlgorithm
    R::RandomizationMethod = NoRand()
end

@views function sample(n::I, d::I, S::HaltonSample, T::Type = Float64) where {I <: Integer}
    bases = nextprimes(one(n), d)
    n_digits = ceil.(I, log.(bases, n))
    λ = n .÷ bases .^ n_digits
    halton_seq = Matrix{T}(undef, d, n)
    for i in axes(halton_seq, 1)
        halton_seq[i, :] .= _vdc(λ[i], n_digits[i], bases[i], T; n)
    end
    return randomize(halton_seq, S.R)
end

# @fastmath @views function vdc(n::I, base::Vector{I}, F=Float64) where I <: Integer
#     n_digits = ceil(Int, log2(n))
#     halton = zeros(F, n, length(base))
#     inv_base = inv.(base)
#     dgs = zeros(I, n_digits)
#     # offset required to place sample in center of interval
#     offset = inv(2n)
#     for sample_idx in eachindex(halton)
#         # increment digit counter by 1
#         _base_sum!(dgs, base)
#         halton[sample_idx, :] .= (evalpoly.(inv_base, dgs) + offset) * inv_base
#     end
#     return halton
# end

using PrecompileTools: @compile_workload, @setup_workload

@setup_workload begin
    # Minimal precompilation workload to reduce time-to-first-sample
    # Focus on the most common use cases with Float64 and Vector{Float64} bounds

    @compile_workload begin
        # Common sample sizes and dimensions for precompilation
        n = 100
        lb = [0.0, 0.0]
        ub = [1.0, 1.0]
        d = 2

        # Precompile the main sampling methods with bounds (most common usage)
        # SobolSample - most used quasi-random sampler
        sample(n, lb, ub, SobolSample())

        # LatinHypercubeSample - very common for sensitivity analysis
        sample(n, lb, ub, LatinHypercubeSample())

        # HaltonSample - another common quasi-random sequence
        sample(n, lb, ub, HaltonSample())

        # GridSample - simple grid sampling
        sample(n, lb, ub, GridSample())

        # RandomSample - basic uniform random sampling
        sample(n, lb, ub, RandomSample())

        # LatticeRuleSample - lattice-based sampling
        sample(n, lb, ub, LatticeRuleSample())

        # GoldenSample (Kronecker) - golden ratio based sampling
        sample(n, lb, ub, GoldenSample())

        # KroneckerSample with explicit dimension
        sample(n, lb, ub, KroneckerSample(d))

        # FaureSample - requires n to be a power of base (base = nextprime(d) = 2 for d=2)
        # Use n=64 which is 2^6
        sample(64, lb, ub, FaureSample())

        # Unit box sampling (without bounds) - also common
        # These are important for users who work directly with unit hypercube
        sample(n, d, SobolSample())
        sample(n, d, LatinHypercubeSample())
        sample(n, d, HaltonSample())
        sample(n, d, GridSample())
        sample(n, d, RandomSample())
        sample(n, d, LatticeRuleSample())
        sample(n, d, GoldenSample())
        sample(n, d, KroneckerSample(d))
        sample(64, d, FaureSample())
        # VanDerCorputSample is 1D only
        sample(n, 1, VanDerCorputSample(base = 2))
        # RandomizedHaltonSample has significant compilation time
        sample(n, d, RandomizedHaltonSample())

        # Precompile with Shift randomization (common randomization method)
        sample(n, lb, ub, SobolSample(R = Shift()))
        sample(n, lb, ub, HaltonSample(R = Shift()))
    end
end

using SciMLTesting, QuasiMonteCarlo

# Extension modules only exist once their trigger package is loaded, and
# ExplicitImports can only scan modules that exist, so the weakdeps have to be
# loaded here for QuasiMonteCarloDistributionsExt to be covered by the checks.
using Distributions

# QuasiMonteCarlo (own package): an extension is part of the package, but it is
# loaded as its own top-level module, so it does not share a `Base.moduleroot`
# with QuasiMonteCarlo and ExplicitImports' `allow_internal_accesses` escape
# hatch does not apply. These are QuasiMonteCarlo's own internals with no public
# spelling, used by QuasiMonteCarloDistributionsExt to implement `sample` and
# `DesignMatrix` for `Distributions.Sampleable`.
ei_kwargs = (;
    all_qualified_accesses_are_public = (;
        ignore = (
            :DistributionDesignMat, :ZERO_SAMPLES_MESSAGE,
            :_check_sequence, :initialize,
        ),
    ),
)

run_qa(QuasiMonteCarlo; ei_kwargs)

module QuasiMonteCarlo

using Sobol: Sobol
using LatticeRules: LatticeRules
using Primes: nextprime, nextprimes
using LinearAlgebra: Diagonal, LowerTriangular, UpperTriangular
using Random: Random, AbstractRNG, rand!, shuffle
using ConcreteStructs: @concrete
using Accessors: @set

"""
    SamplingAlgorithm

Abstract supertype for sampling strategies accepted by [`sample`](@ref).

## Extension rules

Define a concrete subtype and implement
`sample(n::Integer, d::Integer, sampler::YourSampler, T = Float64)`.
The method must return a `d`-by-`n` matrix of elements of type `T` whose columns
are points in the unit box `[0, 1]^d`. It must reject invalid sampler-specific
inputs with an informative exception and must preserve the requested number of
points and dimensions. `sample` applies user-supplied bounds itself, so extensions
should implement the unit-box method rather than a separate bounds method.
"""
abstract type SamplingAlgorithm end

"""
    RandomSamplingAlgorithm <: SamplingAlgorithm

Abstract supertype for samplers that use an RNG to generate randomized point sets.
"""
abstract type RandomSamplingAlgorithm <: SamplingAlgorithm end

"""
    DeterministicSamplingAlgorithm <: SamplingAlgorithm

Abstract supertype for deterministic low-discrepancy samplers.
"""
abstract type DeterministicSamplingAlgorithm <: SamplingAlgorithm end

"""
    RandomizationMethod

Abstract supertype for methods that randomize deterministic point sets with [`randomize`](@ref).
"""
abstract type RandomizationMethod end

const UB_LB_MESSAGE = "Lower bound exceeds upper bound (lb > ub)"
const ZERO_SAMPLES_MESSAGE = "Number of samples must be greater than zero"
const DIM_MISMATCH_MESSAGE = "Dimensionality of lb and ub must match"

function _check_sequence(lb, ub, n::Integer)
    @assert length(lb) == length(ub) DIM_MISMATCH_MESSAGE
    @assert all(x -> x[1] ≤ x[2], zip(lb, ub)) UB_LB_MESSAGE
    return @assert n > 0 ZERO_SAMPLES_MESSAGE
end

_check_sequence(n::Integer) = @assert n > 0 ZERO_SAMPLES_MESSAGE

"""
    RandomSample(; rng = Random.TaskLocalRNG()) <: RandomSamplingAlgorithm

Plain Monte Carlo sampler that draws independent uniform samples from the unit box.
"""
Base.@kwdef @concrete struct RandomSample <: RandomSamplingAlgorithm
    rng::AbstractRNG = Random.TaskLocalRNG()
end

function sample(n::Integer, d::Integer, S::RandomSample, T = Float64)
    _check_sequence(n)
    return rand(S.rng, T, d, n)
end

"""
    sample(n::Integer, d::Integer, sampler::SamplingAlgorithm, T = Float64)
    sample(n::Integer, lb, ub, sampler::SamplingAlgorithm)

Generate `n` sample points with `sampler`.

## Arguments

  - `n`: Positive number of points to generate.
  - `d`: Positive dimension of the unit box. This form returns a `d`-by-`n`
    matrix with values in `[0, 1]`.
  - `lb`: Scalar, tuple, or vector of lower bounds. Its length determines the
    dimension when it is not scalar.
  - `ub`: Scalar, tuple, or vector of upper bounds with the same shape as `lb`.
    Each lower bound must be less than or equal to its corresponding upper bound.
  - `sampler`: Concrete [`SamplingAlgorithm`](@ref) that determines the point
    set construction.

## Optional Positional Arguments

  - `T = Float64`: Element type of the unit-box result. The bounds form infers
    its output element type from `lb`.

## Returns

A matrix whose columns are the generated points. The unit-box form has size
`(d, n)`. The bounds form has size `(length(lb), n)` for collection bounds and
maps every coordinate from `[0, 1]` to its corresponding closed interval
`[lb[i], ub[i]]`.

## Examples

```jldoctest
julia> using QuasiMonteCarlo

julia> unit_points = QuasiMonteCarlo.sample(4, 2, SobolSample());

julia> size(unit_points)
(2, 4)

julia> points = QuasiMonteCarlo.sample(4, [0.0, -1.0], [1.0, 1.0], SobolSample());

julia> all([0.0, -1.0] .<= points .<= [1.0, 1.0])
true
```

## Extension rules

To add a sampler, subtype [`SamplingAlgorithm`](@ref) and implement only the
unit-box form `sample(n, d, sampler, T)`. The implementation must return a
`d`-by-`n` matrix with elements in `[0, 1]`; the bounds form is provided by this
package and delegates to that unit-box method. Do not extend this bounds method
for a new sampler.
"""
function sample(
        n::Integer, lb::T, ub::T,
        S::D
    ) where {
        T <: Union{AbstractVector, Tuple, Number},
        D <: SamplingAlgorithm,
    }
    _check_sequence(lb, ub, n)
    lb = float.(lb)
    ub = float.(ub)
    out = sample(n, length(lb), S, eltype(lb))
    return (ub .- lb) .* out .+ lb
end

# See https://discourse.julialang.org/t/is-there-a-dedicated-function-computing-m-int-log-b-b-m/89776/10
function logi(b::Integer, n::Integer)
    m = round(Int, log(b, n))
    b^m == n || throw(ArgumentError("$n is not a power of $b"))
    return m
end

include("net_utilities.jl")
include("VanDerCorput.jl")
include("Faure.jl")
include("Kronecker.jl")
include("Halton.jl")
include("Sobol.jl")
include("LatinHypercube.jl")
include("RandomizedHalton.jl")
include("Lattices.jl")
include("Section.jl")

"""
    NoRand() <: RandomizationMethod

No randomization is performed on the sampled sequence.
"""
struct NoRand <: RandomizationMethod end

"""
    randomize(x, R::RandomizationMethod)

Apply the randomization method `R` to the sample matrix `x`.
The `NoRand()` method returns `x` unchanged.
"""
randomize(x, S::NoRand) = x

include("RandomizedQuasiMonteCarlo/shifting.jl")
include("RandomizedQuasiMonteCarlo/scrambling_base_b.jl")
include("RandomizedQuasiMonteCarlo/iterators.jl")

include("precompile.jl")

export SamplingAlgorithm,
    sample,
    generate_design_matrices,
    GridSample,
    SobolSample,
    LatinHypercubeSample,
    RandomizedHaltonSample,
    LatticeRuleSample,
    RandomSample,
    HaltonSample,
    VanDerCorputSample,
    GoldenSample,
    KroneckerSample,
    FaureSample,
    randomize,
    RandomizationMethod,
    NoRand,
    Shift,
    ScrambleMethod,
    OwenScramble,
    MatousekScramble,
    DigitalShift,
    DesignMatrix
end # module

# [Design Matrices](@id DesignMatrices)

## API

It is often convenient to generate multiple independent sequences, for error estimation (uncertainty quantification).
The resulting sequences can be stored in what is often called a design matrix.
In this package, this is achieved with the `generate_design_matrices(n, d, ::DeterministicSamplingAlgorithm), ::RandomizationMethod, num_mats)` function. `num_mats` is the number of independent realizations. The resulting design matrix is a vector of matrix of length `num_mats`.

```@docs
QuasiMonteCarlo.generate_design_matrices
```

Instead of generating `num_mats` matrices, it is possible (and more memory efficient) to randomize the same matrix multiple times and perform an operation after each randomization. This is possible using iterators.
To build an iterator use the `DesignMatrix` function.

```@docs
QuasiMonteCarlo.DesignMatrix
```

!!! warning
    
    The method `generate_design_matrices(n, d, sampler, R::NoRand, num_mats, T = Float64)` is an ad hoc way to produce a Design Matrix. Indeed, it creates a deterministic point set in dimension `d × num_mats` and splits it into `num_mats` point set of dimension `d`. The resulting sequences have no QMC guarantees.
    This seems to have been proposed in Section 5.1 of [*Saltelli, A. et al. (2010)*](https://www.sciencedirect.com/science/article/pii/S0010465509003087)[^1] to do uncertainty quantification.
    See [this discussion](https://github.com/SciML/QuasiMonteCarlo.jl/pull/79#discussion_r1222946133) for a visual proof.

[^1]: Saltelli, A., Annoni, P., Azzini, I., Campolongo, F., Ratto, M., & Tarantola, S. (2010). Variance based sensitivity analysis of model output. Design and estimator for the total sensitivity index. Computer physics communications, 181(2), 259-270.
## Example

```@example 2
using QuasiMonteCarlo, Random, StatsBase
Random.seed!(1234)
m = 4
d = 3
b = QuasiMonteCarlo.nextprime(d)
N = b^m # Number of points
pad = 2m # Can also choose something as `2m` to get "better" randomization
num_mats = 5

f(x) = prod(x) * 2^length(x) # test function ∫f(x)dᵈx = 1

# Randomize over num_mats = 5 independent Randomized Faure sequences
iterator = DesignMatrix(N, d, FaureSample(R = OwenScramble(base = b, pad = pad)), num_mats)

μ = [mean(f(c) for c in eachcol(X)) for X in iterator]
```

Using `std(μ)` then gives you the estimated variance of your RQMC prediction.

```@example 2
# Or using `generate_design_matrices`. Note that this is less memory efficient since it allocate space for 5 large big matrices.
μ = [mean(f(c) for c in eachcol(X))
     for X in QuasiMonteCarlo.generate_design_matrices(N,
    d,
    FaureSample(R = OwenScramble(base = b, pad = pad)),
    num_mats)]
```

# Sampler APIs

## Sample

```@docs
QuasiMonteCarlo.sample
```

## Samplers

Samplers are divided into two subtypes

```@docs
SamplingAlgorithm
QuasiMonteCarlo.RandomSamplingAlgorithm
QuasiMonteCarlo.DeterministicSamplingAlgorithm
```

### Deterministic Sampling Algorithm

All `DeterministicSamplingAlgorithm` have `NoRand()` as their default `RandomizationMethod`, see [Randomization methods](@ref Randomization) and [Design Matrices section](@ref DesignMatrices) for more information on randomization.

```@docs
GridSample
```

```@docs
SobolSample
```

!!! warning
    
    The QuasiMonteCarlo.jl package relies on the [Sobol.jl](https://github.com/JuliaMath/Sobol.jl) package to sample Sobol nets. The choice, there is to NOT start the sequence at `0`. This is debatable, see this [issue](https://github.com/JuliaMath/Sobol.jl/issues/31#issuecomment-1528136486) and ref therein for more context.

```@docs
VanDerCorputSample
FaureSample
LatticeRuleSample
HaltonSample
GoldenSample
KroneckerSample
```

### Random Sampling Algorithm

```@docs
RandomSample
LatinHypercubeSample
RandomizedHaltonSample
```

# [Randomization methods](@id Randomization)

Most of the methods presented in [Sampler](@ref Samplers) are deterministic, i.e. `X = sample(n, d, ::DeterministicSamplingAlgorithm)` will always produce the same sequence $X = (X_1, \dots, X_n)$.

The main issue with deterministic Quasi Monte Carlo sampling is that it does not allow easy error estimation as opposed to plain Monte Carlo, where the variance can be estimated.

A Randomized Quasi Monte Carlo method must respect the two following criteria:

 1. Have $X_i\sim \mathbb{U}([0,1]^d)$ for each $i\in \{1,\cdots, n\}$.
 2. Preserve the QMC properties, i.e. the randomized $X$ still has low discrepancy.

This randomized version is unbiased and can be used to obtain a confidence interval or to do sensitivity analysis.

A good reference is the [book by A. Owen](https://artowen.su.domains/mc/qmcstuff.pdf), especially the Chapters 15, 16 and 17.

## API for randomization

```@docs
RandomizationMethod
```

There are two ways to obtain a randomized sequence:

  - Either directly use `QuasiMonteCarlo.sample(n, d, DeterministicSamplingAlgorithm(R = SomeRandomizationMethod()))` or `sample(n, lb, up, DeterministicSamplingAlgorithm(R = RandomizationMethod()))`.
  - Or, given $n$ points $d$-dimensional points, all in $[0,1]^d$ one can do `randomize(X, SomeRandomizationMethod())` where $X$ is a $d\times n$-matrix.

```@docs
randomize
```

The default method of `DeterministicSamplingAlgorithm` is `NoRand`

```@docs
NoRand
```

To obtain multiple independent randomizations of a sequence, i.e. Design Matrices, look at the [Design Matrices section](@ref DesignMatrices).

!!! note
    
    In most other QMC packages, randomization is performed "online" as the points are samples. Here, randomization is performed after the deterministic sequence is generated. Both methods are useful in different contexts. The former is generally faster to produce one randomized sequence, while the latter is faster to produce independent realizations of the sequence.
    
    **PRs are welcomed** to add "online" version of the sequence! See [this comment for inspiration](https://github.com/SciML/QuasiMonteCarlo.jl/pull/57#issuecomment-1326662016).
    
    Another way to view the two approaches is: given a computational budget of $N$ points, one can
    
     1. Put all of it into a sequence of size, $N$, thus having the best estimator $\hat{\mu}_N$. The price to pay is that this estimation is not associated with a variance estimation.
     2. Divide your computational budget into $N = n\times M$ to get $M$ independent estimator $\hat{\mu}_n$. From there, one can compute the empirical variance of the estimator.

## Scrambling methods

```julia
abstract type ScrambleMethod <: RandomizationMethod end
```

```@docs
ScrambleMethod
```

`ScramblingMethods(b, pad, rng)` are well suited for $(t,m,d)$-nets in base $b$. `b` is the base used to scramble and `pad` the number of bits in `b`-ary decomposition, i.e. $y \simeq \sum_{k=1}^{\texttt{pad}} y_k/\texttt{b}^k$.

The `pad` is generally chosen as $\gtrsim \log_b(n)$.

!!! warning
    
    In principle, the base `b` used for scrambling methods `ScramblingMethods(b, pad, rng)` can be an arbitrary integer.
    However, to preserve good Quasi Monte Carlo properties, it must match the base of the sequence to scramble.
    For example, (deterministic) Sobol sequences are base $b=2$, $(t,m,d)$ sequences while (deterministic) Faure sequences are $(t,m,d)$ sequences in prime base i.e. $b$ is an arbitrary prime number.

The implemented `ScramblingMethods` are

  - `DigitalShift` the simplest and fastest method. For a point $x\in [0,1]^d$ it does $y_k = (x_k + U_k) \mod b$ where $U_k \sim \mathbb{U}(\{0, \cdots, b-1\})$

```@docs
DigitalShift
```

  - `MatousekScramble` a.k.a. Linear Matrix Scramble is what people use in practice. Indeed, the observed performances are similar to `OwenScramble` for a lesser numerical cost.

```@docs
MatousekScramble
```

  - `OwenScramble` a.k.a. Nested Uniform Scramble is the most understood theoretically, but is more costly to operate.

```@docs
OwenScramble
```

## Other methods

`Shift(rng)` a.k.a. Cranley-Patterson Rotation. It is by far the fastest method; it is used in `LatticeRuleScramble` for example.

```@docs
Shift
```

## Example

Randomization of a Faure sequence with various methods.

### Generation

```@example 1
using QuasiMonteCarlo, Random
Random.seed!(1234)
m = 4
d = 3
b = QuasiMonteCarlo.nextprime(d)
N = b^m # Number of points
pad = m # Can also choose something as `2m` to get "better" randomization

# Unrandomized low discrepancy sequence
x_faure = QuasiMonteCarlo.sample(N, d, FaureSample())

# Randomized version
x_uniform = rand(d, N) # plain i.i.d. uniform
x_shift = randomize(x_faure, Shift())
x_nus = randomize(x_faure, OwenScramble(base = b, pad = pad)) # equivalent to sample(N, d, FaureSample(R = OwenScramble(base = b, pad = pad)))
x_lms = randomize(x_faure, MatousekScramble(base = b, pad = pad))
x_digital_shift = randomize(x_faure, DigitalShift(base = b, pad = pad))
```

### Visualization of different methods

Plot the resulting sequences along dimensions `1` and `3`.

```@example 1
using Plots
# Setting I like for plotting
default(fontfamily = "Computer Modern",
    linewidth = 1,
    label = nothing,
    grid = true,
    framestyle = :default)

d1 = 1
d2 = 3 # you can try every combination of dimension (d1, d2)
sequences = [x_uniform, x_faure, x_shift, x_digital_shift, x_lms, x_nus]
names = [
    "Uniform",
    "Faure (deterministic)",
    "Shift",
    "Digital Shift",
    "Matousek Scramble",
    "Owen Scramble"
]
p = [plot(thickness_scaling = 1.5, aspect_ratio = :equal) for i in sequences]
for (i, x) in enumerate(sequences)
    scatter!(p[i], x[d1, :], x[d2, :], ms = 1.5, c = 1, grid = false)
    title!(names[i])
    xlims!(p[i], (0, 1))
    ylims!(p[i], (0, 1))
    yticks!(p[i], [0, 1])
    xticks!(p[i], [0, 1])
    hline!(p[i], range(0, 1, step = 1 / 4), c = :gray, alpha = 0.2)
    vline!(p[i], range(0, 1, step = 1 / 4), c = :gray, alpha = 0.2)
    hline!(p[i], range(0, 1, step = 1 / 2), c = :gray, alpha = 0.8)
    vline!(p[i], range(0, 1, step = 1 / 2), c = :gray, alpha = 0.8)
end
plot(p..., size = (800, 600))
```

### $(t,m,d)$-net visualization

Faure nets and their scrambled versions are digital $(t,m,d)$-net, which means they have strong equipartition properties.
On the following plot, we can (visually) verify that with Nested Uniform Scrambling, it also works with Linear Matrix Scrambling and Digital Shift.
You must see one point per rectangle of volume $1/b^m$. Points on the "left" border of rectangles are included, while those on the "right" are excluded. See [Chapter 15.7](https://artowen.su.domains/mc/qmcstuff.pdf) and Figure 15.10 for more details.

```@example 1
d1 = 1
d2 = 3 # you can try every combination of dimension (d1, d2)
x = x_nus # Owen Scramble, you can try x_lms and x_digital_shift
p = [plot(thickness_scaling = 1.5, aspect_ratio = :equal) for i in 0:m]
for i in 0:m
    j = m - i
    xᵢ = range(0, 1, step = 1 / b^(i))
    xⱼ = range(0, 1, step = 1 / b^(j))
    scatter!(p[i + 1], x[d1, :], x[d2, :], ms = 1.5, c = 1, grid = false)
    xlims!(p[i + 1], (0, 1.01))
    ylims!(p[i + 1], (0, 1.01))
    yticks!(p[i + 1], [0, 1])
    xticks!(p[i + 1], [0, 1])
    hline!(p[i + 1], xᵢ, c = :gray, alpha = 0.2)
    vline!(p[i + 1], xⱼ, c = :gray, alpha = 0.2)
end
plot(p..., size = (800, 600))
```

!!! note
    
    To check if a point set is a $(t,m,d)$-net, you can use the function `istmsnet` defined in the [tests file](https://github.com/SciML/QuasiMonteCarlo.jl/blob/2dce9905e564a85e1280115cc8af071674fc7d80/test/runtests.jl#L34) of this package.
    It uses the excellent [IntervalArithmetic.jl](https://github.com/JuliaIntervals/IntervalArithmetic.jl) package.

# QuasiMonteCarlo.jl: Quasi-Monte Carlo (QMC) Samples Made Easy

QuasiMonteCarlo.jl is a lightweight package for generating Quasi-Monte Carlo (QMC) samples
using various different methods.

## Installation

To install QuasiMonteCarlo.jl, use the Julia package manager:

```julia
using Pkg
Pkg.add("QuasiMonteCarlo")
```

## Get Started

### Basic API

```julia
using QuasiMonteCarlo, Distributions
lb = [0.1, -0.5]
ub = [1.0, 20.0]
n = 5
d = 2

s = QuasiMonteCarlo.sample(n, lb, ub, GridSample())
s = QuasiMonteCarlo.sample(n, lb, ub, Uniform())
s = QuasiMonteCarlo.sample(n, lb, ub, SobolSample())
s = QuasiMonteCarlo.sample(n, lb, ub, LatinHypercubeSample())
s = QuasiMonteCarlo.sample(n, lb, ub, LatticeRuleSample())
s = QuasiMonteCarlo.sample(n, lb, ub, HaltonSample())
s = QuasiMonteCarlo.sample(n, lb, ub, RandomizedHaltonSample())
```

The output `s` is a matrix, so one can use things like `@uview` from
[UnsafeArrays.jl](https://github.com/oschulz/UnsafeArrays.jl) for a stack-allocated
view of the `i`th point:

```julia
using UnsafeArrays
@uview s[:, i]
```

### MC vs QMC

We illustrate the gain of QMC methods over plain Monte Carlo using the 5-dimensional example from Section 15.9 in the [book by A. Owen](https://artowen.su.domains/mc/qmcstuff.pdf).

```@example MCvsQMC; continued = true
f₁(𝐱) = prod(1 + √(12) / 5 * (xⱼ - 1 / 2) for xⱼ in 𝐱)
μ_exact = 1 # = ∫ f₁(𝐱) d⁵𝐱
```

One can estimate the integral $\mu$ using plain Monte Carlo, or Quasi Monte Carlo or Randomized Quasi Monte Carlo. See the other section of this documentation for more information on the functions used in the example.

```@example MCvsQMC
using QuasiMonteCarlo, Random, Distributions
using Plots;
default(fontfamily = "Computer Modern");
Random.seed!(1234)
d = 5 # Dimension (= prime base for Faure net)
b = 2 # Base for Sobol net
m_max = 19
m_max_Faure = 8
N = b^m_max

# Generate sequences
seq_MC = QuasiMonteCarlo.sample(N, d, Uniform()) # Monte Carlo i.i.d. Uniform sampling
seq_QMC_Sobol = QuasiMonteCarlo.sample(N, d, SobolSample()) # Sobol net
seq_RQMC_Sobol = QuasiMonteCarlo.sample(N,
    d,
    SobolSample(R = OwenScramble(base = b, pad = 32))) # Randomized version of Sobol net
seq_RQMC_Faure = QuasiMonteCarlo.sample(d^m_max_Faure,
    d,
    FaureSample(R = OwenScramble(base = d, pad = 32))) # Randomized version of Faure net

# Estimate the integral for different n with different estimator μ̂ₙ
μ_MC = [mean(f₁(x) for x in eachcol(seq_MC[:, 1:(b^m)])) for m in 1:m_max]
μ_QMC_Sobol = [mean(f₁(x) for x in eachcol(seq_QMC_Sobol[:, 1:(b^m)])) for m in 1:m_max]
μ_RQMC_Sobol = [mean(f₁(x) for x in eachcol(seq_RQMC_Sobol[:, 1:(b^m)])) for m in 1:m_max]
μ_RQMC_Faure = [mean(f₁(x) for x in eachcol(seq_RQMC_Faure[:, 1:(d^m)]))
                for m in 1:m_max_Faure]

# Plot the error |μ̂-μ| vs n
plot(b .^ (1:m_max), abs.(μ_MC .- μ_exact), label = "MC")
plot!(b .^ (1:m_max), abs.(μ_QMC_Sobol .- μ_exact), label = "QMC Sobol")
plot!(b .^ (1:m_max), abs.(μ_RQMC_Sobol .- μ_exact), label = "RQMC Sobol")
plot!(d .^ (1:m_max_Faure), abs.(μ_RQMC_Faure .- μ_exact), label = "RQMC Faure")
plot!(n -> n^(-1 / 2), b .^ (1:m_max), c = :black, s = :dot, label = "n^(-1/2)")
plot!(n -> n^(-3 / 2), b .^ (1:m_max), c = :black, s = :dash, label = "n^(-3/2)")
# n^(-3/2) is the theoretical scaling for scrambled nets e.g. Theorem 17.5. in https://artowen.su.domains/mc/qmcstuff.pdf
xlims!(1, 1e6)
ylims!(1e-9, 1)
xaxis!(:log10)
yaxis!(:log10)
xlabel!("n", legend = :bottomleft)
ylabel!("|μ̂-μ|")
```

## Adding a new sampling method

Adding a new sampling method is a two-step process:

 1. Add a new SamplingAlgorithm type.
 2. Implement `sample(n, d, sampler, T = Float64)` for that type.

The unit-box method must return a matrix with dimension `d` by `n`, where `d` is
the sample-space dimension and `n` is the number of samples. Every element must
lie in `[0, 1]`. The package supplies the bounds method, so extensions should not
implement `sample(n, lb, ub, sampler)`.

**Example**

```julia
struct NewAmazingSamplingAlgorithm{OPTIONAL} <: SamplingAlgorithm end

function sample(n::Integer, d::Integer, ::NewAmazingSamplingAlgorithm, T = Float64)
    return fill(convert(T, 0.5), d, n)
end
```

## Contributing

  - Please refer to the
    [SciML ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://sciml.github.io/ColPrac/stable/)
    for guidance on PRs, issues, and other matters relating to contributing to SciML.

  - See the [SciML Style Guide](https://github.com/SciML/SciMLStyle) for common coding practices and other style decisions.
  - There are a few community forums:
    
      + The #diffeq-bridged and #sciml-bridged channels in the
        [Julia Slack](https://julialang.org/slack/)
      + The #diffeq-bridged and #sciml-bridged channels in the
        [Julia Zulip](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged)
      + On the [Julia Discourse forums](https://discourse.julialang.org)
      + See also [SciML Community page](https://sciml.ai/community/)

## Reproducibility

```@raw html
<details><summary>The documentation of this SciML package was built using these direct dependencies,</summary>
```

```@example
using Pkg # hide
Pkg.status() # hide
```

```@raw html
</details>
```

```@raw html
<details><summary>and using this machine and Julia version.</summary>
```

```@example
using InteractiveUtils # hide
versioninfo() # hide
```

```@raw html
</details>
```

```@raw html
<details><summary>A more complete overview of all dependencies and their versions is also provided.</summary>
```

```@example
using Pkg # hide
Pkg.status(; mode = PKGMODE_MANIFEST) # hide
```

```@raw html
</details>
```

```@eval
using TOML
using Markdown
version = TOML.parse(read("../../Project.toml", String))["version"]
name = TOML.parse(read("../../Project.toml", String))["name"]
link_manifest = "https://github.com/SciML/" * name * ".jl/tree/gh-pages/v" * version *
                "/assets/Manifest.toml"
link_project = "https://github.com/SciML/" * name * ".jl/tree/gh-pages/v" * version *
               "/assets/Project.toml"
Markdown.parse("""You can also download the
[manifest]($link_manifest)
file and the
[project]($link_project)
file.
""")
```

# Choosing the right type (Float32, Float64, etc.)

## Output type

The Julia default for Floats is `Float64`.
For QMC computations that already require a large amount of memory, this is usually not needed.
In fact, like neural network packages, most QMC packages will not let you control the output type.
The underlying C/C++ implementation is made with `Float32` to save memory.

In this package, thanks to Julia's multiple dispatch and generic coding strategy, with a very small coding effort, one can get flexible output type, useful in different situations.
For example, for research/academic purposes, it might be useful to have the exact `Rational` representation of a Faure or Sobol sequence, or `Float16`, `Float64`.

!!! warning
    
    This feature might not be available consistently yet for every QMC sequence or randomization method.

### Example different output types

```@example 3
using QuasiMonteCarlo, Random
using BenchmarkTools, StatsBase
Random.seed!(1234)
m = 4
d = 2
b = QuasiMonteCarlo.nextprime(d)
N = b^m # Number of points
pad = m # Can also choose something as `2m` to get "better" randomization

QuasiMonteCarlo.sample(N, d, FaureSample(R = NoRand())) # Float64
```

```@example 3
QuasiMonteCarlo.sample(N, d, FaureSample(R = NoRand()), Float32) # Float32
```

```@example 3
QuasiMonteCarlo.sample(N, d, FaureSample(R = NoRand()), Rational) # Exact Rational
```

## Intermediate bits array type

For scrambling methods, large bit arrays with values in `0:base` are created.
Again, the default for storing is `Int` (i.e. generally `Int64` as 64-bit Julia is the common installation) which can dramatically affect memory usage when doing multiple large computations.
To avoid this, one can define the `ScrambleMethod` with `Int32` (or else) like `OwenScramble(base = Int32(b), pad = Int32(m))`.[^1]

[^1]: Currently, both `pad` and `base` must be of the same type. This might change.
### Example

To illustrate the memory gain, let's look at a bigger example with multiple randomization using [iterators](@ref DesignMatrices)

```julia
m = 6
d = 3
b = QuasiMonteCarlo.nextprime(d)
N = b^m # Number of points
pad = 32 # Can also choose something as `2m` to get "better" randomization
num_mats = 50

f(x) = prod(x) * 2^length(x) # test function ∫f(x)dᵈx = 1

iterator32 = DesignMatrix(N,
    d,
    FaureSample(R = OwenScramble(base = Int32(b), pad = Int32(pad))),
    num_mats)
iterator64 = DesignMatrix(N,
    d,
    FaureSample(R = OwenScramble(base = Int(b), pad = Int(pad))),
    num_mats)
@btime [mean(f(c) for c in eachcol(X)) for X in iterator32]
# ~21.974 ms (1302 allocations: 2.18 MiB)
@btime [mean(f(c) for c in eachcol(X)) for X in iterator64]
# ~21.532 ms (1302 allocations: 3.01 MiB)
```

The memory usage drops from `3Mib` to `2Mib`! It is not exactly a factor 2 because of all the other computations happening.
The number of allocations is the same, and the timing is similar. In larger cases, a time gain is also observed.

!!! note
    
    For very large computations, one can change both the output type and the intermediate bit array types to minimize memory usage, e.g. `DesignMatrix(N, d, FaureSample(R = OwenScramble(base = Int32(b), pad = Int32(pad))), num_mats, Float32)`
